
;OS Info Dump Version 3.0 - DednDave, 2-2011

;#############################################################################################################

        INCLUDE dTest.inc

;#############################################################################################################

BUFFER_COLUMNS   EQU 80               ;default display buffer columns
BUFFER_ROWS      EQU 1024             ;default display buffer rows
WINDOW_WIDTH_ADD EQU 27               ;default window added width in pixels
WINDOW_HEIGHT    EQU 462              ;default window height in pixels
STATUS_BAR       EQU MF_CHECKED       ;default status bar state, MF_UNCHECKED = off, MF_CHECKED = on
BACK_COLOR       EQU MyBlack_0        ;default background color
FORE_COLOR       EQU MyAmber_6        ;default foreground color

;#############################################################################################################

;## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##

;test equates

static_ctrl EQU 0
thrd_ctrl   EQU 0
thrd_mode   EQU DMODE_FULL_AUTO ;DMODE_SEMI_AUTO, DMODE_FULL_AUTO, DMODE_MANUAL
thrd_time1  EQU 62
thrd_time2  EQU 1000

        .DATA
        ALIGN    4

;test data

ams AppModeStruct <0,dCU_Base,dCU_MaxCmd,CmdVectUsr,AppNameUsr,dCP_Base,dCP_MaxCmd,CmdVectPma,AppNamePma>
; hRcvr         dd ?
; nBaseCmd      dd ?        ;dCU_Base or dCP_Base (equates)
; nMaxCmd       dd ?        ;dCU_MaxCmd or dCP_MaxCmd (equates)
; lpCmdVect     dd ?        ;command dispatch vector table
; AppNamePtr    dd ?
; nPmaBaseCmd   dd ?
; nPmaMaxCmd    dd ?
; lpPmaCmdVect  dd ?
; PmaAppNamePtr dd ?

CmdVectUsr       dd dCC_Acknowledge,dCC_Continue,dCC_Flush
CmdVectPma       dd dCC_Acknowledge,dCC_Continue,dCC_Flush,dCP_Print

SequenceX        dd 0
SeqFlush         dd 1
SequenceR        dd ?
cdTimeCnt        dd ?

HexOut      PROTO :DWORD,:DWORD
TxtThrd     PROTO

TxtBuf      db BUFFER_COLUMNS dup(0),13,10,0
teststr     db '123456789 ',0
thrdend     db -1
thrdended   db -1
testcnt     dd 8
testcrlf    db 0dh,0ah

rPSemaphore      db 0

PmAppName        db 'dTest.exe '
PmCmdLine        db 9 dup(0)

PmaErrText       db 'Unable to Open Presentation Manager Application',0


;## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##

        .DATA
        ALIGN    4

cg CoordinateGroup <>
; h         CoordInfo <<>,1,8,0,0,0,0,0,0,0>
; v         CoordInfo <<>,1,12,0,0,0,0,0,0,0>
;   s        SCROLLINFO <sizeof SCROLLINFO,SIF_RANGE or SIF_PAGE or SIF_POS,0,32,0,0,0>
;     cbSize           dd sizeof SCROLLINFO
;     fMask            dd SIF_RANGE or SIF_PAGE or SIF_POS
;     nMin             dd 0
;     nMax             dd 32
;     nPage            dd 0
;     nPos             dd 0
;     nTrackPos        dd 0
;   CellsUsed        dd 1
;   CellSize         dd ?      ;default: h=8, v=12
;   Mult             dd 0
;   Shft             dd 0
;   CurPos           dd 0
;   NewPos           dd 0
;   BarSize          dd 0
;   WheelDiv         dd 0
;   WheelCnt         dd 0

tr RECT <0,0,-1,-1>
; left             dd 0
; top              dd 0
; right            dd -1
; bottom           dd -1

vs ViewSettings <0,WINDOW_HEIGHT,80Ch,BACK_COLOR,FORE_COLOR>
; WndWidth         dd 0                 ;default filled in at init
; WndHeight        dd WINDOW_HEIGHT
; DefaultTextSize  dd 80Ch              ;default = 8x12
; BackColor        dd BACK_COLOR        ;background color
; ForeColor        dd FORE_COLOR        ;foreground color

FeCount          dd FeList
SizeID           dd -1
LocCntX          dd 0
LocCntY          dd 0
MaxFlag          dd -1

WinStates        dd CID_STATUSBAR and STATE_MASK
BsgPosX          dd -1
BsgPosY          dd -1
BngPosX          dd -1
BngPosY          dd -1
wrUpdate         dd wrUpd

CustomColors     dd MyBlack_0,MyBlue_1,MyGreen_2,MyCyan_3
                 dd MyRed_4,MyMagenta_5,MyAmber_6,MyLtGrey_7
                 dd MyGrey_8,MyLtBlue_9,MyLtGreen_A,MyLtCyan_B
                 dd MyLtRed_C,MyLtMagenta_D,MyYellow_E,MyWhite_F

WheelVect        dd WvNrm,WvShf,WvCtl,WhNrm,WhShf
WheelPtrs        dd ShftVrtState,CtrlVrtState,HrzState,ShftHrzState

WinCreateTable   dd WS_CHILD or WS_VISIBLE or SBARS_SIZEGRIP,StatusClass
                 dd WS_CHILD or SBS_HORZ,ScrollClass
                 dd WS_CHILD or SBS_VERT,ScrollClass
                 dd WS_CHILD or SBS_SIZEBOX,ScrollClass
                 dd WS_CHILD or SBS_SIZEGRIP,ScrollClass
                 dd WS_CHILD or WS_VISIBLE,TxtClass

;main menu table - item qty, each item: (lpNewItem,uIDNewItem,uFlags)

MenuTable        dd 3                                                       ;'File' menu
                 dd szSaveAs,IDM_FILE_SAVEAS,MF_GRAYED                      ;'Save As...'
                 dd NULL,NULL,MF_SEPARATOR                                  ;MFT_SEPARATOR
                 dd szExit,IDM_FILE_EXIT,MF_STRING                          ;'Exit'
                 dd szFileMenu                                              ;'File'
                 dd 2                                                       ;'Edit' menu
                 dd szCopyAll,IDM_EDIT_COPYALL,MF_GRAYED                    ;'Copy All'
                 dd szCopyForum,IDM_EDIT_COPYFORUM,MF_GRAYED                ;'Copy Forum'
                 dd szEditMenu                                              ;'Edit'
                 dd 5                                                       ;'View' menu
                 dd szForeColor,IDM_FORE_COLOR,MF_STRING                    ;'Foreground Color'
                 dd szBackColor,IDM_BACK_COLOR,MF_STRING                    ;'Background Color'
                 dd NULL,NULL,MF_SEPARATOR                                  ;MFT_SEPARATOR
                 dd NULL,NULL,MF_SEPARATOR                                  ;MFT_SEPARATOR
                 dd szStatusBar,IDM_VIEW_STATUSBAR
StbState         dd STATUS_BAR                                              ;'Status Bar'
                 dd szViewMenu                                              ;'View'
                 dd 3                                                       ;'Help' menu
                 dd szHelpMenu,IDM_HELP_HELP,MF_STRING                      ;'Help'
                 dd NULL,NULL,MF_SEPARATOR                                  ;MFT_SEPARATOR
                 dd szAbout,IDM_HELP_ABOUT,MF_STRING                        ;'About'
                 dd szHelpMenu                                              ;'Help'
                 dd 2                                                       ;'Custom Colors' submenu
                 dd szResetFore,IDM_VIEW_RESETFORE,MF_STRING                ;'Reset Fore'
                 dd szResetBack,IDM_VIEW_RESETBACK,MF_STRING                ;'Reset Back'
                 dd szCustom                                                ;'Custom Colors'
                 dd 5                                                       ;'Mouse Wheel' submenu
                 dd szShftVert,IDM_VIEW_MWSHFTVRT
ShftVrtState     dd MF_CHECKED                                              ;'Shft Vert'
                 dd szCtrlVert,IDM_VIEW_MWCTRLVRT
CtrlVrtState     dd MF_CHECKED                                              ;'Ctrl Vert'
                 dd NULL,NULL,MF_SEPARATOR                                  ;MFT_SEPARATOR
                 dd szHorz,IDM_VIEW_MWHRZ
HrzState         dd MF_CHECKED                                              ;'Horz'
                 dd szShftHorz,IDM_VIEW_MWSHFTHRZ
ShftHrzState     dd MF_CHECKED                                              ;'Shft Horz'
                 dd szWheel                                                 ;'Mouse Wheel'

szFileMenu       db 'File',0
szEditMenu       db 'Edit',0
szViewMenu       db 'View',0
szHelpMenu       db 'Help',0
szSaveAs         db 'Save As...',0
szExit           db 'Exit',0
szCopyAll        db 'Copy All',0
szCopyForum      db 'Copy Forum',0
szForeColor      db 'Foreground Color',0
szBackColor      db 'Background Color',0
szStatusBar      db 'Status Bar',0
szAbout          db 'About',0
szTextSize       db 'Text Size',0
szResetFore      db 'Reset Foreground Colors',0
szResetBack      db 'Reset Background Colors',0
szCustom         db 'Custom Colors',0
szVert           db 'Vert',0
szShftVert       db 'Shft Vert',0
szCtrlVert       db 'Ctrl Vert',0
szHorz           db 'Horizontal',0
szShftHorz       db 'Shft Horz',0
szWheel          db 'Mouse Wheel',0

WndClass         db 'dTestClass',0
TxtClass         db 'dTestText',0
ScrollClass      db 'ScrollBar',0
StatusClass      db 'msctls_statusbar32',0
AppNameUsr       db 'dTest User Mode',0
AppNamePma       db 'dTest Presentation Mode',0
AboutText        db 'dTest',10
                 db 'Copyright ',169,' 2011 David R. Sheldon'
NullStr          db 0
FileTypeStrs     db 'Text Files',0,'*.txt',0,'All Files',0,'*.*',0,0

IccErrText       db 'InitCommonControls Failed',0
AllocErrText     db 'Heap Allocation Error',0
FileErrTitle     db 'Error Writing File',0
FileErrText      db 'Select a different file name and/or location and try again',0
CbErrTitle       db 'Error Copying to Clipboard',0
CbErrText        db 'Close any programs that may be using the clipboard and try again',0
HelpText         db 'Help is on the way! ;)',0

FSSemaphore      db 1 ;file save semaphore
CCSemaphore      db 1 ;color chooser semaphore
HHSemaphore      db 1 ;help-help semaphore
HASemaphore      db 1 ;help-about semaphore
MinSemaphore     db 0
dUpdateMode      db 0 ;0=manual, 1=semi-auto (update on each newline), 3=full-auto (newline or exit dTxtOut)
dUpdateFlags     db 0
sUpdateEnable    db 0
BufDisable       db 0

;*************************************************************************************************************

        .DATA?
        ALIGN    4

lpCmndLineFull   dd ?
lpCmndLine       dd ?
hInstance        dd ?
hIcon            dd ?
hCursor          dd ?
hFont            dd ?
hMenu            dd ?
hEditMenu        dd ?
hHeap            dd ?
hBlock           dd ?
hWin             dd ?
BlockUsed        dd ?
BufferColumns    dd ?
BufferRows       dd ?
RowLength        dd ? ;(BufferColumns+5) AND 0FFFFFFFCh
BufCalc1         dd ? ;RowLength/4
BufCalc2         dd ? ;BufferRows-1
BufCalc3         dd ? ;RowLength*(BufferRows-1)/4
BufCalc4         dd ? ;RowLength*BufferRows/4
SecondRowAddr    dd ? ;address of second buffer row
LastRowAddr      dd ? ;address of last buffer row
LastRow          dd ? ;initial value = BufferRows-1 = BufCalc2

StbHeight        dd ?
StbPosY          dd ?
StbWidth         dd ?
WrkWidth         dd ?
WrkHeight        dd ?
MinFlag          dd ?
CCMode           dd ?

ControlHandles   LABEL   DWORD
hStatus          dd ? ;ID = 1001h
hHScroll         dd ? ;ID = 1002h
hVScroll         dd ? ;ID = 1004h
hSizeBoxNG       dd ? ;ID = 1008h
hSizeBoxG        dd ? ;ID = 1010h
hTxt             dd ? ;ID = 1020h

CustomBack       dd 16 dup(?)
CustomFore       dd 16 dup(?)

wr RECT <>
pr RECT <>
; left             dd ?
; top              dd ?
; right            dd ?
; bottom           dd ?

lf LOGFONT <>
; lfHeight         dd ?
; lfWidth          dd ?
; lfEscapement     dd ?
; lfOrientation    dd ?
; lfWeight         dd ?
; lfItalic         db ?
; lfUnderline      db ?
; lfStrikeOut      db ?
; lfCharSet        db ?
; lfOutPrecision   db ?
; lfClipPrecision  db ?
; lfQuality        db ?
; lfPitchAndFamily db ?
; lfFaceName       db LF_FACESIZE dup(?) ;LF_FACESIZE = 32

ssf SavedSettingsFile <>
; szMarker         db 10 dup(?) ;'dTest.bin',0
; wFileSize        dw ?         ;120
; wWindowWidth     dw ?
; wWindowHeight    dw ?
; wFlagsTextSize   dw ?
; rgbBackColor     db 3 dup(?)
; rgbForeColor     db 3 dup(?)
; rgbCustomBack    db 48 dup(?)
; rgbCustomFore    db 48 dup(?)

FeList           dw FELISTLENGTH dup(?)
WheelKeys        db ?
WrFlag           db ?
StFlag           db ?

;#############################################################################################################

        .CODE

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

        ALIGN   16

WndProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;WndProc routine for the main window

;------------------------------------------------------------------------------

        mov     ecx,[esp+8]                                  ;uMsg


        cmp     ecx,WM_PAINT                                 ;0Fh
        JZ      DefWindowProc

        cmp     ecx,WM_SETCURSOR                             ;20h
        JZ      DefWindowProc

        cmp     ecx,WM_NCHITTEST                             ;84h
        JZ      DefWindowProc

        cmp     ecx,WM_CTLCOLORSCROLLBAR                     ;137h
        JZ      DefWindowProc

        cmp     ecx,WM_NCMOUSEMOVE                           ;0A0h
        JZ      DefWindowProc

        cmp     ecx,WM_ENTERIDLE                             ;121h
        JZ      DefWindowProc

        cmp     ecx,WM_THEMECHANGED                          ;31Ah - highest handled message
        JA      DefWindowProc

;------------------------------------------------------------------------------

;WM_HSCROLL/WM_VSCROLL

        push    ebp
        cmp     cx,WM_HSCROLL                                ;114h
        mov     ebp,esp
        jz      Scrol0

        cmp     cx,WM_VSCROLL                                ;115h
        jnz     Wheel0

;----------------------

Scrol0: push    ebx
        shl     ecx,6                                        ;cg.v-cg.h = HvOfs = 64 = 2^6
        push    esi
        lea     ebx,cg[ecx-HvOfs*WM_HSCROLL]                 ;EBX points to either cg.h or cg.v structure
        push    edi
        movzx   ecx,word ptr [ebp+16]                        ;ECX = wParam low word = SB_request
        mov     eax,[ebx].CoordInfo.s.nPos
        cmp     ecx,SB_THUMBTRACK                            ;SB_THUMBTRACK = 5
        mov     edx,[ebx].CoordInfo.CellSize
        jz      Scrol4

        xor     esi,esi
        cmp     ecx,SB_LEFT                                  ;SB_LEFT or SB_TOP = 6
        jz      Scrol5

        or      ecx,ecx                                      ;SB_LINELEFT or SB_LINEUP = 0
        mov     esi,eax
        jz      Scrol3

        mov     edi,[ebx].CoordInfo.s.nMax
        sub     edi,[ebx].CoordInfo.s.nPage
        inc     edi
        cmp     ecx,SB_LINERIGHT                             ;SB_LINERIGHT or SB_LINEDOWN = 1
        jz      Scrol1

        cmp     ecx,SB_RIGHT                                 ;SB_RIGHT or SB_BOTTOM = 7
        jz      Scrol2

        mov     edx,[ebx].CoordInfo.s.nPage
        cmp     ecx,SB_PAGELEFT                              ;SB_PAGELEFT or SB_PAGEUP = 2
        jz      Scrol3

        cmp     ecx,SB_PAGERIGHT                             ;SB_PAGERIGHT or SB_PAGEDOWN = 3
        jnz     Scrol6

Scrol1: add     esi,edx
        jc      Scrol2

        cmp     esi,edi
        jbe     Scrol5

Scrol2: mov     esi,edi
        jmp short Scrol5

Scrol3: sub     esi,edx
        jnc     Scrol5

        xor     esi,esi
        jmp short Scrol5

Scrol4: movzx   esi,word ptr [ebp+18]                        ;ESI = wParam high word = position

Scrol5: cmp     eax,esi
        jz      Scrol6

        mov     [ebx].CoordInfo.s.nPos,esi
        INVOKE  SetScrollInfo,[ebp+20],SB_CTL,ebx,TRUE       ;[EBP+20] = lParam = control handle
        mov     eax,[ebx].CoordInfo.Mult
        mov     ecx,[ebx].CoordInfo.Shft
        mul     esi
        shr     edx,cl
        cmp     edx,[ebx].CoordInfo.CurPos
        jz      Scrol6

        mov     [ebx].CoordInfo.NewPos,edx
        INVOKE  InvalidateRgn,hTxt,NULL,TRUE

Scrol6: pop     edi

Scrol7: pop     esi
        pop     ebx
        pop     ebp
        xor     eax,eax
        ret     16

;------------------------------------------------------------------------------

;WM_MOUSEWHEEL/WM_MOUSEHWHEEL

Wheel0: xor     eax,eax
        cmp     cx,WM_MOUSEWHEEL                             ;20Ah
        jz      Wheel1

        cmp     cx,WM_MOUSEHWHEEL                            ;20Eh
        jnz     WndPr0

        or      eax,WKEY_SHIFT or WKEY_CONTROL               ;0Ch

;----------------------

Wheel1: movzx   ecx,byte ptr WheelKeys
        cmp     ecx,WKEY_SHIFT or WKEY_CONTROL               ;0Ch
        jae     Wheel4

        add     ecx,eax                                      ;normal vert has no disable
        jz      Wheel2

        cmp     ecx,10h
        ja      Wheel4

        mov     edx,WheelPtrs[ecx-4]                         ;normal vert has no disable
        cmp     ch,[edx]                                     ;CH = MF_UNCHECKED = 0
        jz      Wheel4

Wheel2: push    ecx
        INVOKE  GetClientRect,[ebp+8],offset pr
        movzx   edx,word ptr [ebp+22]                        ;EDX = lParam high word = y screen coordinate
        movzx   eax,word ptr [ebp+20]                        ;EAX = lParam low word = x screen coordinate
        push    edx
        push    eax
        INVOKE  ScreenToClient,[ebp+8],esp
        pop     eax
        pop     edx
        or      eax,eax
        pop     ecx
        js      Wheel4

        or      edx,edx
        js      Wheel4

        cmp     eax,pr.right
        jae     Wheel4

        test byte ptr WinStates,CID_STATUSBAR and STATE_MASK ;1
        mov     eax,pr.bottom
        jz      Wheel3

        sub     eax,StbHeight

Wheel3: cmp     eax,edx
        jle     Wheel4

        push    ebx
        movsx   edx,word ptr [ebp+18]                        ;EDX = wParam high word = distance
        push    esi
        mov     eax,WHEEL_DELTA                              ;120
        push    edi
        mov     ebx,WM_VSCROLL                               ;115h
        xor     esi,esi
        xor     edi,edi
        jmp dword ptr WheelVect[ecx]

Wheel4: pop     ebp
        xor     eax,eax
        ret     16

WhShf:: or      esi,SB_PAGERIGHT                             ;3, also SB_PAGEDOWN
        jmp short Wheel5

WhNrm:: or      esi,SB_LINERIGHT                             ;1, also SB_LINEDOWN
        mov     eax,cg.h.WheelDiv

Wheel5: or      edi,CID_HSCROLLBAR and STATE_MASK            ;2
        mov     ecx,offset cg.h.WheelCnt                     ;(structure)
        dec     ebx                                          ;WM_HSCROLL = 114h
        jmp short Wheel7

WvShf:: or      esi,SB_PAGEUP                                ;2, also SB_PAGELEFT
        jmp short Wheel6

WvNrm:: mov     eax,cg.v.WheelDiv                            ;ESI = SB_LINEUP = 0, also SB_LINELEFT

Wheel6: or      edi,CID_VSCROLLBAR and STATE_MASK            ;4
        mov     ecx,offset cg.v.WheelCnt                     ;(structure)

Wheel7: test    edi,WinStates
        jz      WheelB

        shl     edi,1
        add     edx,[ecx]
        push    ecx
        mov     edi,ControlHandles[edi]                      ;(structure)
        push    edx
        jns     Wheel9
                                                             ;
        xor     esi,SB_LINEUP xor SB_LINEDOWN                ;1
        neg     edx
        jmp short Wheel9

Wheel8: push    edx
        push    eax
        INVOKE  PostMessage,[ebp+8],ebx,esi,edi
        pop     eax
        pop     edx

Wheel9: sub     edx,eax
        jnc     Wheel8

        pop     ebx
        add     eax,edx
        or      ebx,ebx
        pop     ecx
        jns     WheelA

        neg     eax

WheelA: mov     [ecx],eax

WheelB: pop     edi
        pop     esi
        pop     ebx
        pop     ebp
        xor     eax,eax
        ret     16

WvCtl:: push    2
        or      edx,edx
        pop     ecx
        jns     WheelC

        neg     edx
        neg     ecx

WheelC: cmp     eax,edx
        ja      WheelB

        mov     cg.v.WheelCnt,esi
        pop     edi
        pop     esi
        mov     eax,SizeID
        pop     ebx
        add     eax,ecx
        jmp     CmmndA

;------------------------------------------------------------------------------

WndPr0: cmp     ecx,WM_SIZE                  ;5
        mov     edx,[ebp+8]                  ;hWnd
        jz      wSize0

        cmp     ecx,WM_GETMINMAXINFO         ;24h
        jz      MinMx0

;------------------------------------------------------------------------------

;WM_MOVE

        cmp     ecx,WM_MOVE                  ;3
        jnz     Keys00

;----------------------

        call    IsNotNormal
        jnz     wMove0

        call dword ptr wrUpdate

wMove0: pop     ebp
        xor     eax,eax
        ret     16

;------------------------------------------------------------------------------

;WM_SIZE

;            MaxFlag   MinFlag
;Normalized    hWin  client width
;Minimized     hWin       0
;Maximized      0    client width

;wParam:
;
;SIZE_RESTORED  EQU 0
;The window has been resized, but neither the SIZE_MINIMIZED nor SIZE_MAXIMIZED value applies
;
;SIZE_MINIMIZED EQU 1
;The window has been minimized
;
;SIZE_MAXIMIZED EQU 2
;The window has been maximized
;
;SIZE_MAXSHOW   EQU 3
;Message is sent to all pop-up windows when some other window has been restored to its former size
;
;SIZE_MAXHIDE   EQU 4
;Message is sent to all pop-up windows when some other window is maximized

wSize0: shr     ecx,1                        ;ECX = 2
        sub     ecx,[ebp+16]                 ;wParam
        jz      wSize3                       ;SIZE_MAXIMIZED

        jc      wSize4                       ;SIZE_MAXSHOW or SIZE_MAXHIDE

        sub     cl,2
        jz      wSize1                       ;SIZE_RESTORED

        inc     ecx
        mov     MaxFlag,edx                  ;SIZE_MINIMIZED
        mov     MinFlag,ecx
        jmp short wSize4

wSize1: cmp     cl,WrFlag
        jz      wSize2

        call    WrAdj

wSize2: push    edx
        call dword ptr wrUpdate
        pop     ecx

wSize3: mov     MaxFlag,ecx
        movzx   ecx,word ptr [ebp+20]        ;lParam low word = client width
        movzx   eax,word ptr [ebp+22]        ;lParam high word = client height
        mov     MinFlag,ecx
        call    wmSize

;----------------------

wSize4: pop     ebp
        xor     eax,eax
        ret     16

;------------------------------------------------------------------------------

;WM_GETMINMAXINFO

MinMx0: mov     edx,[ebp+20]                 ;lParam
        mov     [edx].MINMAXINFO.ptMinTrackSize.x,208

MinMx1: pop     ebp
        xor     eax,eax
        ret     16

;------------------------------------------------------------------------------

Keys00: cmp     cx,WM_KEYUP                  ;101h
        mov     eax,[ebp+16]                 ;wParam
        jz      Keys06

        cmp     cx,WM_KEYDOWN                ;100h
        jnz     Keys07

;----------------------

;WM_KEYDOWN

        test byte ptr [ebp+23],(KF_REPEAT/100h) ;lParam high byte, 40h
        jnz     Keys05

        cmp     eax,VK_SHIFT                 ;10h
        mov     edx,WKEY_SHIFT               ;4
        jz      Keys01

        shl     edx,1                        ;EDX = WKEY_CONTROL = 8
        cmp     eax,VK_CONTROL               ;11h
        jnz     Keys05

;----------------------

Keys01: test    dl,WheelKeys
        jz      Keys03

        jmp short Keys05

Keys02: test    dl,WheelKeys
        jz      Keys05

Keys03: xor     WheelKeys,dl

Keys04: xor     eax,eax
        mov     cg.h.WheelCnt,eax
        mov     cg.v.WheelCnt,eax

Keys05: pop     ebp
        JMP     DefWindowProc

;----------------------

;WM_KEYUP

Keys06: cmp     eax,VK_SHIFT                 ;10h
        mov     edx,WKEY_SHIFT               ;4
        jz      Keys02

        shl     edx,1                        ;EDX = WKEY_CONTROL = 8
        cmp     eax,VK_CONTROL               ;11h
        jz      Keys02

        jmp     Keys05

;----------------------

Keys07: cmp     cx,WM_SYSKEYDOWN             ;104h
        jz      Keys09

        cmp     cx,WM_SYSKEYUP               ;105h
        jz      Keys0A

        cmp     ecx,WM_SETFOCUS              ;7
        jz      Keys0B

        cmp     cx,WM_EXITMENULOOP           ;212h
        jz      Keys08

        cmp     cx,WM_COPYDATA               ;4Ah
        jz      CData0

        cmp     cx,WM_ENTERMENULOOP          ;211h
        jnz     Cmmnd0

;----------------------

;WM_ENTERMENULOOP

        mov     edx,WKEY_MLOOP               ;20h
        jmp     Keys01

;----------------------

;WM_EXITMENULOOP

;we may or may not see the first ALT key down message
;we will see the ALT key up message, however

Keys08: mov     edx,WKEY_MLOOP               ;20h
        jmp     Keys02

;----------------------

;WM_SYSKEYDOWN (must exit via DefWindowProc)

;because we may or may not see the first ALT key down message,
;we can't ignore repeats like WM_KEYDOWN

Keys09: cmp     eax,VK_MENU                  ;12h
        mov     edx,WKEY_ALT                 ;10h
        jz      Keys01

        jmp     Keys05

;----------------------

;WM_SYSKEYUP (must exit via DefWindowProc)

Keys0A: cmp     eax,VK_MENU                  ;12h
        mov     edx,WKEY_ALT                 ;10h
        jz      Keys02

        jmp     Keys05

;----------------------

;WM_SETFOCUS

Keys0B: push    ebx
        INVOKE  GetKeyState,VK_SHIFT         ;10h
        shr     eax,13
        and     eax,WKEY_SHIFT               ;4
        xchg    eax,ebx
        INVOKE  GetKeyState,VK_CONTROL       ;11h
        shr     eax,12
        and     eax,WKEY_CONTROL             ;8
        or      ebx,eax
        INVOKE  GetKeyState,VK_MENU          ;12h
        shr     eax,7
        and     eax,WKEY_ALT                 ;10h
        or      eax,ebx
        pop     ebx
        mov     WheelKeys,al
        jmp     Keys04

;------------------------------------------------------------------------------

;WM_COPYDATA

;CopyDataStruct STRUCT
; dwData    dd ?
; cbData    dd ?
; lpData    dd ?

;CopyDataHdr STRUCT
; hXmtr     dd ?
; hRcvr     dd ?
; nSequence dd ?
; dwCommand dd ?

CData0: mov     eax,[ebp+16]                 ;wParam
        mov     ecx,ams.hRcvr
        push    ebx
        mov     edx,[ebp+20]                 ;lParam
        cmp     eax,ecx
        mov     ebx,hWin
        jz      CDataM

        or      ecx,ecx
        jnz     CData1

CDataM: cmp     ebx,[edx].COPYDATASTRUCT.dwData
        mov     ecx,[edx].COPYDATASTRUCT.cbData
        jnz     CData1

        sub     ecx,sizeof CopyDataHdr
        mov     edx,[edx].COPYDATASTRUCT.lpData
        jc      CData1

        cmp     eax,[edx].CopyDataHdr.hXmtr
        jnz     CData1

        cmp     ebx,[edx].CopyDataHdr.hRcvr
        mov     eax,[edx].CopyDataHdr.dwCommand
        jnz     CData1

        xor     ebx,ebx
        cmp     eax,ams.nBaseCmd                ;alias for dCm_ACKNOWLEDGE
        ja      CDataN

        jb      CData1

        cmp     ebx,ams.hRcvr
        jnz     CDataO

        mov     eax,[edx].CopyDataHdr.hXmtr
        mov     ams.hRcvr,eax
        INVOKE  SndAck,ebx
        inc     ebx
        mov     SequenceX,ebx
        jmp short CDat3

CDataN: cmp     ebx,ams.hRcvr
        jz      CData1

CDataO: cmp     eax,ams.nMaxCmd
        mov     ebx,[edx].CopyDataHdr.nSequence
        ja      CData1

        test    al,3
        jnz     CData1

        sub     eax,ams.nBaseCmd
        add     eax,ams.lpCmdVect
        jmp dword ptr [eax]

;ams AppModeStruct
; hRcvr         dd ?
; nBaseCmd      dd ?        ;dCU_Base or dCP_Base (equates)
; nMaxCmd       dd ?        ;dCU_MaxCmd or dCP_MaxCmd (equates)
; lpCmdVect     dd ?        ;command dispatch vector table
; AppNamePtr    dd ?

;EAX = CopyDataHdr.dwCommand
;EBX = CopyDataHdr.nSequence
;ECX = COPYDATASTRUCT.cbData - sizeof CopyDataHdr (size of COPYDATA data)
;EDX = COPYDATASTRUCT.lpData (address of CopyDataHdr structure)

CData1: pop     ebx
        pop     ebp
        JMP     DefWindowProc

CDat2:: INVOKE  SndAck,ebx

CDat3:: pop     ebx
        jmp     wSize4

;------------------------------------------------------------------------------

;WM_COMMAND

Cmmnd0: and     eax,0FFFFh
        cmp     cx,WM_COMMAND                ;111h
        jnz     WndPr1

;----------------------

        cmp     eax,IDM_VIEW_RESETBACK       ;40
        jz      Cmmnd1

        cmp     eax,IDM_VIEW_RESETFORE       ;41
        jz      Cmmnd1

        cmp     eax,IDM_FILE_SAVEAS          ;32
        jz      Cmmnd2

        cmp     eax,IDM_FORE_COLOR           ;37
        jz      Cmmnd3

        cmp     eax,IDM_BACK_COLOR           ;38
        jz      Cmmnd3

        cmp     eax,IDM_HELP_HELP            ;34
        jz      Cmmnd4

        cmp     eax,IDM_HELP_ABOUT           ;35
        jz      Cmmnd5

;------------------------------------------------------------------------------

;IDM_VIEW_STATUSBAR

        cmp     eax,IDM_VIEW_STATUSBAR       ;39
        jnz     Cmmnd7

;----------------------

        push    ebx
        push    esi
        call    StbToggle
        jmp     Scrol7

;------------------------------------------------------------------------------

;IDM_VIEW_RESETBACKFORE/IDM_VIEW_RESETFORE

Cmmnd1: shl     eax,6
        push    edi
        add     eax,offset CustomBack-64*IDM_VIEW_RESETBACK ; (structure)
        push    esi
        xchg    eax,edi
        call    CcRst
        pop     esi
        pop     edi
        jmp     wSize4

;------------------------------------------------------------------------------

;IDM_FILE_SAVEAS

Cmmnd2: mov     edx,offset FSSemaphore
        mov     ecx,offset FSaveAs
        jmp short Cmmnd6

;----------------------

;IDM_FORE_COLOR/IDM_BACK_COLOR

Cmmnd3: mov     edx,offset CCSemaphore
        mov     ecx,offset CColor
        jmp short Cmmnd6

;----------------------

;IDM_HELP_HELP

Cmmnd4: mov     edx,offset HHSemaphore
        mov     ecx,offset HHelp
        jmp short Cmmnd6

;----------------------

;IDM_HELP_ABOUT

Cmmnd5: mov     edx,offset HASemaphore
        mov     ecx,offset HAbout

Cmmnd6: INVOKE  DlgThread,ecx,edx,eax
        jmp     wSize4

;------------------------------------------------------------------------------

;IDM_VIEW_MWSHFTVRT/IDM_VIEW_MWCTRLVRT
;IDM_VIEW_MWHRZ/IDM_VIEW_MWSHFTHRZ

Cmmnd7: cmp     eax,IDM_VIEW_MWSHFTVRT       ;42
        jb      Cmmnd9

        cmp     eax,IDM_VIEW_MWSHFTHRZ       ;45
        ja      Cmmnd9

;----------------------

        mov     edx,eax
        shl     edx,2
        add     edx,offset WheelPtrs-4*IDM_VIEW_MWSHFTVRT
        mov     edx,[edx]
        mov     ecx,[edx]
        xor     ecx,MF_CHECKED
        mov     [edx],ecx
        INVOKE  CheckMenuItem,hMenu,eax,ecx
        jmp     wSize4

;------------------------------------------------------------------------------

Cmmnd8: pop     ebp
        JMP     DefWindowProc

Cmmnd9: cmp     eax,IDM_FILE_EXIT            ;33
        jz      CmmndC

;------------------------------------------------------------------------------

;IDM_TEXT_SIZE

CmmndA: cmp     eax,IDM_TEXT_SIZE            ;65
        jb      TxPop

        cmp     eax,FeCount
        jae     Cmmnd8

        test    eax,1
        jz      Cmmnd8

        mov     edx,SizeID
        cmp     eax,edx
        jz      wSize4

;----------------------

        push    eax
        INVOKE  CheckMenuItem,hMenu,edx,MF_BYCOMMAND or MF_UNCHECKED
        INVOKE  DeleteObject,hFont
        pop     edx
        call    SelectSize
        call    MakeFont
        call    TextCalc
        call    sUpdate
        jmp     wSize4

;------------------------------------------------------------------------------

;IDM_EDIT_COPYALL/IDM_EDIT_COPYFORUM

TxPop:: cmp     eax,IDM_EDIT_COPYALL         ;36
        jz      CmmndB

        cmp     eax,IDM_EDIT_COPYFORUM       ;47 (IDM_EDIT_COPYALL+11)
        jnz     WndPr2

;----------------------

CmmndB: sub     eax,IDM_EDIT_COPYALL-COPY_MODE
        INVOKE  CbCopy,eax
        jmp     wSize4

;------------------------------------------------------------------------------

;IDM_FILE_EXIT

CmmndC: INVOKE  PostMessage,edx,WM_SYSCOMMAND,SC_CLOSE,NULL

CmmndD: mov     eax,wrDis
        xchg    eax,wrUpdate
        jmp     wSize4

;------------------------------------------------------------------------------

WndPr1: cmp     ecx,WM_CREATE                ;1
        jz      WndPr3

        cmp     ecx,WM_CLOSE                 ;10h
        jz      WndPr4

        cmp     ecx,WM_DESTROY               ;2
        jz      WndPr5

        cmp     cx,WM_NCDESTROY              ;82h
        jz      WndPr6

        cmp     ecx,WM_SETTINGCHANGE         ;1Ah
        jz      WndPr7

        cmp     ecx,WM_THEMECHANGED          ;31Ah
        jz      Theme0

        cmp     ecx,WM_DISPLAYCHANGE         ;7Eh
        jz      WndPr8

;----------------------

WndPr2: pop     ebp
        JMP     DefWindowProc

;------------------------------------------------------------------------------

;WM_CREATE

WndPr3: push    ebx
        push    esi
        push    edi
        call    wmCreate
        jmp     Scrol6

;------------------------------------------------------------------------------

;WM_CLOSE

WndPr4: mov     eax,ams.hRcvr
        or      eax,eax
        jz      WndPrX

        cmp     eax,[ebp+16]
        jz      WndPrX

        push    edx
        INVOKE  SendMessage,eax,WM_CLOSE,edx,edx
        pop     edx

WndPrX: INVOKE  DestroyWindow,edx
        jmp     CmmndD

;------------------------------------------------------------------------------

;WM_DESTROY

WndPr5: mov     BufDisable,cl
        INVOKE  PostQuitMessage,NULL
        jmp     CmmndD

;------------------------------------------------------------------------------

;WM_NCDESTROY

WndPr6: push    ebx
        push    esi
        push    edi
        call    dWinExit
        jmp     Scrol6

;------------------------------------------------------------------------------

;WM_SETTINGCHANGE

WndPr7: cmp dword ptr [ebp+16],SPI_SETNONCLIENTMETRICS ;wParam = 2Ah
        jnz     wSize4

;----------------------

;WM_THEMECHANGED

Theme0:

;        push    1
;        pop     eax
;        xchg    al,MbFlag
;        dec     eax
;        jz      wSize4
;
;        inc     eax
;        INVOKE  CreateThread,eax,eax,MinThrd,eax,eax,eax

jmp wSize4

        push    ebx
        call    IsNotNormal
        xchg    eax,ebx
        jz      Theme1

;        mov byte ptr MbFlag,1
        jmp short Theme2

Theme1: call    WrAdj                         ;window size/position
;        call    MbMin                         ;minimum window width

Theme2: and     bl,1
        jnz     Theme3

        inc     ebx
        test    ebx,WinStates
        jnz     Theme4

Theme3: mov     StFlag,bl
        jmp short Theme5

Theme4: call    StMet                         ;status bar metrics

Theme5: push    esi
        push    edi
        call    ScMet                         ;scroll bar/wheel metrics
        jmp     Scrol6

;------------------------------------------------------------------------------

;WM_DISPLAYCHANGE

WndPr8: push    edx
        call    WkMet                         ;screen width/height
        pop     edx
        call    IsNotNormal
        jnz     WndPr9

        call    WrAdj                         ;window size/position
        jmp     wSize4

WndPr9: mov     WrFlag,al
        jmp     wSize4

;------------------------------------------------------------------------------

WndProc ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

StbToggle PROC

        mov     eax,StbState
        xor     al,MF_CHECKED
        mov     ebx,MaxFlag
        push    eax
        mov     StbState,eax
        INVOKE  CheckMenuItem,hMenu,IDM_VIEW_STATUSBAR,eax
        or      ebx,ebx
        pop     ecx
        jz      CtlUpdate                         ;EBX = hWin if not maximized

        mov     edx,StbHeight
        jecxz   Toggl0                            ;turning it off

        neg     edx                               ;turning it on

Toggl0: mov     eax,wr.bottom
        mov     esi,wr.top
        sub     eax,esi
        sub     eax,edx
        jecxz   Toggl1                            ;turning it off

        cmp     eax,WrkHeight
        ja      CtlUpdate

Toggl1: mov     edx,wr.left
        mov     ecx,wr.right
        sub     ecx,edx
        INVOKE  MoveWindow,ebx,edx,esi,ecx,eax,TRUE
        ret

StbToggle ENDP

;*************************************************************************************************************

        ALIGN   16

CtlUpdate PROC

        INVOKE  GetClientRect,hWin,offset pr
        mov     eax,pr.bottom
        mov     ecx,pr.right

;*******************************************************

;wmSize

;Call With: EAX = client height
;           ECX = client width
;
;  Returns: EAX = nonzero if InvalidateRgn was called to update text window
;
;Each control window has a bit in WinStates that indicates the current show/hide state for that window.
;The "old" WinStates flags reside in the WinStates dword.
;The "new" WinStates flags reside at [EBP-12], and replaces the "old" WinStates flags when done.
;
;For each control window, the new state/position is calculated.
;If a control window needs to be repositioned, ESI is incremented and 7 parameters are pushed onto the stack.
;These represent the last 7 of the 8 parameters for DeferWindowPos, or the 7 parameters for SetWindowPos.
;For DeferWindowPos, the remaining parameter is pushed inside the defer loop.
;Also, the new position and size values for the control window are updated for later comparison.
;
;Once the stack is set up and the newWinStates dword is created:
; 1) defer window positions as required (ESI indicates count) or set window position for a single window
; 2) hide any control windows that are showing and need to be hidden
;    show any control windows that are hidden and need to be showing
; 3) update WinStates dword

;----------------------

;stack frame TEXTEQUates

;                     <[EBP+16]> ;RETurn address
;                     <[EBP+12]> ;saved EBX contents
;                     <[EBP+8]>  ;saved ESI contents
;                     <[EBP+4]>  ;saved EDI contents
;                     <[EBP]>    ;saved EBP contents
hUpdate       TEXTEQU <[EBP-4]>  ;horizontal update
vUpdate       TEXTEQU <[EBP-8]>  ;vertical update
newWinStates  TEXTEQU <[EBP-12]> ;new WinStates dword

;----------------------

;SP_FLAGSET            EQU SWP_NOZORDER or SWP_NOACTIVATE or SWP_NOOWNERZORDER
;
;CID_STATUSBAR         EQU 1001h ;4097
;CID_HSCROLLBAR        EQU 1002h ;4098
;CID_VSCROLLBAR        EQU 1004h ;4100
;CID_SIZEBOXN          EQU 1008h ;4104
;CID_SIZEGRIP          EQU 1010h ;4112
;
;ControlHandles   LABEL dword
;hStatus          dd ?
;hHScroll         dd ?
;hVScroll         dd ?
;hSizeBoxNG       dd ?
;hSizeBoxG        dd ?

;----------------------

wmSize::
        push    ebx
        push    esi
        push    edi
        push    ebp
        or      ebx,-1
        mov     ebp,esp
        push    ebx
        push    ebx
        xchg    eax,edi                           ;EDI = client height
        inc     ebx                               ;EBX = newWinStates
        mov     eax,cg.v.s.nMax                   ;EAX = cg.v.s.nMax
        mov     edx,ebx                           ;EDX = 0
        mov     esi,ebx                           ;ESI = control update count
        cmp     ebx,StbState
        push    ebx                               ;[EBP-4] = newWinStates

;----------------------

;status bar

        jz      sScrl0

        sub     edi,StbHeight
        inc     ebx                               ;set CID_STATUSBAR bit
        cmp     ecx,StbWidth
        jnz     sStBar

        cmp     edi,StbPosY
        jz      sScrl0

sStBar: push    SP_FLAGSET                        ;uFlags
        inc     esi
        push    StbHeight                         ;cy (height)
        push    ecx                               ;cx (width)
        mov     StbWidth,ecx
        push    edi                               ;y (y pos)
        push    edx                               ;x (x pos)
        mov     StbPosY,edi
        push    edx                               ;hWndInsertAfter
        push    hStatus                           ;hWnd

;----------------------

;scroll bar test-retest

;EAX = cg.v.s.nMax
;EBX = newWinStates
;ECX = client width
;EDX = 0
;ESI = control update count
;EDI = client height (less status bar height)

sScrl0: mov     edx,cg.h.s.nMax
        push    eax
        push    edx
        sub     edx,cg.h.CellSize
        sub     eax,cg.v.CellSize
        cmp     edx,ecx
        jb      sScrl1

        sub     edi,cg.v.BarSize
        or      ebx,CID_HSCROLLBAR and STATE_MASK

sScrl1: cmp     eax,edi
        jb      sSpos0

        sub     ecx,cg.h.BarSize
        test    ebx,CID_HSCROLLBAR and STATE_MASK
        jnz     sScrl2

        cmp     edx,ecx
        jb      sScrl2

        or      ebx,CID_HSCROLLBAR and STATE_MASK
        sub     edi,cg.v.BarSize

sScrl2: or      ebx,CID_VSCROLLBAR and STATE_MASK

;----------------------

;scroll bar page/position

sSpos0: pop     edx
        pop     eax
        sub     edx,ecx
        jnc     sSpos1

        xor     edx,edx

sSpos1: cmp     edx,cg.h.s.nPos
        jae     sSpos2

        mov     hUpdate,edx
        mov     cg.h.s.nPos,edx

sSpos2: sub     eax,edi
        mov     cg.h.s.nPage,ecx
        jnc     sSpos3

        xor     eax,eax

sSpos3: cmp     eax,cg.v.s.nPos
        jae     sVScr0

        mov     vUpdate,eax
        mov     cg.v.s.nPos,eax

;----------------------

;vertical scroll bar

sVScr0: xor     edx,edx
        test    ebx,CID_VSCROLLBAR and STATE_MASK
        mov     cg.v.s.nPage,edi
        mov     eax,SP_FLAGSET
        jz      sHScr0

        push    eax                               ;uFlags
        push    edi                               ;cy (height)
        inc     esi
        push    cg.h.BarSize                      ;cx (width)
        push    edx                               ;y (y pos)
        push    ecx                               ;x (x pos)
        push    edx                               ;hWndInsertAfter
        push    hVScroll                          ;hWnd

;----------------------

;horizontal scroll bar

sHScr0: test    ebx,CID_HSCROLLBAR and STATE_MASK
        jz      sTxtW0

        push    eax                               ;uFlags
        inc     esi
        push    cg.v.BarSize                      ;cy (height)
        push    ecx                               ;cx (width)
        push    edi                               ;y (y pos)
        push    edx                               ;x (x pos)
        push    edx                               ;hWndInsertAfter
        push    hHScroll                          ;hWnd

;----------------------

;text window

sTxtW0: cmp     ecx,tr.right
        jnz     sTxtW1

        cmp     edi,tr.bottom
        jz      sSzBx0

sTxtW1: push    eax                               ;uFlags
        inc     esi
        mov     tr.right,ecx
        push    edi                               ;cy (height)
        push    ecx                               ;cx (width)
        mov     tr.bottom,edi
        push    edx                               ;y (y pos)
        push    edx                               ;x (x pos)
        push    edx                               ;hWndInsertAfter
        push    hTxt                              ;hWnd

;----------------------

;size boxes

;EAX = SP_FLAGSET
;EBX = newWinStates
;ECX = text window width
;EDX = 0
;ESI = control update count
;EDI = text window height

sSzBx0: test    ebx,CID_VSCROLLBAR and STATE_MASK
        jz      SetPos

        test    ebx,CID_HSCROLLBAR and STATE_MASK
        jz      SetPos

        test    ebx,CID_STATUSBAR and STATE_MASK
        jz      sSzBx1

        or      ebx,CID_SIZEBOXN and STATE_MASK
        cmp     ecx,BngPosX
        mov     eax,hSizeBoxNG
        jnz     sSzBx2

        cmp     edi,BngPosY
        jz      SetPos

        mov     BngPosX,ecx
        mov     BngPosY,edi
        jmp short sSzBx2

sSzBx1: or      ebx,CID_SIZEGRIP and STATE_MASK
        cmp     ecx,BsgPosX
        mov     eax,hSizeBoxG
        jnz     sSzBx2

        cmp     edi,BsgPosY
        jz      SetPos

        mov     BsgPosX,ecx
        mov     BsgPosY,edi

sSzBx2: push    SP_FLAGSET                        ;uFlags
        push    cg.v.BarSize                      ;cy (height)
        inc     esi
        push    cg.h.BarSize                      ;cx (width)
        push    edi                               ;y (y pos)
        push    ecx                               ;x (x pos)
        push    edx                               ;hWndInsertAfter
        push    eax                               ;hWnd

;----------------------

;set window position(s)

;ESI = window update count
;stack: 7 parms per ESI count

SetPos: dec     esi
        mov     newWinStates,ebx
        jz      sSetWP

        inc     esi
        jz      State0

        INVOKE  BeginDeferWindowPos,esi

sDefer: push    eax
        CALL    DeferWindowPos
        dec     esi
        jnz     sDefer

        INVOKE  EndDeferWindowPos,eax
        jmp short State0

sSetWP: CALL    SetWindowPos

;----------------------

;    show = newWinStates AND NOT(old_WinStates)
;NOT hide = newWinStates OR NOT(old_WinStates)

;ESI = 0

State0: mov     eax,WinStates
        mov     edi,offset ControlHandles ;(structure)
        mov     ebp,newWinStates
        not     eax
        mov     ebx,ebp
        or      esi,5
        and     ebp,eax              ;EBP = show
        or      ebx,eax              ;EBX = NOT hide
        xor     ecx,ecx
        test    ebp,CID_VSCROLLBAR and STATE_MASK
        jz      State1

        mov     cg.v.WheelCnt,ecx
        
State1: test    ebp,CID_HSCROLLBAR and STATE_MASK
        jz      State2

        mov     cg.h.WheelCnt,ecx

State2: xor     eax,eax
        shr     ebp,1                ;we take 1 bit from EBP and 1 bit from EBX
        rcl     eax,1                ;the result is either 0, 1, or 5
        shl     eax,1                ;a result of 4 won't occur, as it
        shr     ebx,1                ;would indicate both show and hide
        rcl     eax,1
        cmp     al,1                 ;no action required = 1
        jz      State3

        INVOKE  ShowWindow,[edi],eax ;SW_HIDE = 0, SW_SHOW = 5

State3: dec     esi
        lea     edi,[edi+4]          ;next control handle
        jnz     State2

;----------------------

;update scroll bar info and WinStates dword

ScInf0: pop     ebx
        lea     edi,[esi+1]          ;EDI = TRUE
        test    ebx,CID_VSCROLLBAR and STATE_MASK
        mov     WinStates,ebx
        jz      ScInf1

        INVOKE  SetScrollInfo,hVScroll,SB_CTL,offset cg.v.s,edi

ScInf1: test    ebx,CID_HSCROLLBAR and STATE_MASK
        jz      dsScr0

        INVOKE  SetScrollInfo,hHScroll,SB_CTL,offset cg.h.s,edi

;----------------------

;deadspace scroll update

dsScr0: pop     eax
        add     eax,1
        jz      dsScr1

        dec     eax
        mov     ecx,cg.v.Shft      ;(structure) maybe
        mul dword ptr cg.v.Mult
        shr     edx,cl
        mov     ebx,edx
        mov     cg.v.NewPos,edx
        jmp short dsScr2

dsScr1: mov     ebx,cg.v.NewPos

dsScr2: pop     eax
        add     eax,1
        jz      dsScr3

        dec     eax
        mov     ecx,cg.h.Shft
        mul dword ptr cg.h.Mult
        shr     edx,cl
        mov     cg.h.NewPos,edx
        jmp short dsScr4

dsScr3: mov     edx,cg.h.NewPos

dsScr4: cmp     ebx,cg.v.CurPos
        jnz     dsScr5

        cmp     edx,cg.h.CurPos
        jz      wSexit

dsScr5: INVOKE  InvalidateRgn,hTxt,esi,edi

;----------------------

;exit routine

wSexit: pop     ebp
        pop     edi
        pop     esi
        pop     ebx
        ret

CtlUpdate ENDP

;*************************************************************************************************************

dCC_Acknowledge PROC

;EBX = CopyDataHdr.nSequence
;ECX = COPYDATASTRUCT.cbData - sizeof CopyDataHdr (size of COPYDATA data)
;EDX = COPYDATASTRUCT.lpData (address of CopyDataHdr structure)

P_Ack0: mov     eax,SeqFlush
        or      eax,eax
        jz      P_Ack0

        cmp     eax,ebx
        jnz     P_Ack1

        xchg    eax,SequenceR

P_Ack1: jmp     CDat3        ;no ack return

dCC_Acknowledge ENDP

;*************************************************************************************************************

dCC_Continue PROC

        mov dword ptr cdTimeCnt,cdTIMEOUT
        jmp     CDat3        ;no ack return

dCC_Continue ENDP

;*************************************************************************************************************

dCC_Flush PROC

P_Flsh: mov     eax,SeqFlush
        or      eax,eax
        jz      P_Flsh

        xchg    eax,SequenceR
        jmp     CDat3        ;no ack return

dCC_Flush ENDP

;*************************************************************************************************************

dCP_Print PROC

;ECX = COPYDATASTRUCT.cbData - sizeof CopyDataHdr (size of COPYDATA data)
;EDX = COPYDATASTRUCT.lpData (address of CopyDataHdr structure)

        add     edx,sizeof CopyDataHdr
        INVOKE  dTxtOut,edx
        jmp     CDat2        ;send ack return

dCP_Print ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

SndData PROC    dwCmd:DWORD,dwLen:DWORD,lpDat:DWORD

;COPYDATASTRUCT STRUCT
; dwData    dd ?
; cbData    dd ?
; lpData    dd ?

;CopyDataHdr STRUCT
; hXmtr     dd ?
; hRcvr     dd ?
; nSequence dd ?
; dwCommand dd ?

        xor     eax,eax
        push    ebx
        xchg    eax,SeqFlush
        xor     ebx,ebx
        jmp short sData1

sData0: INVOKE  Sleep,ebx

sData1: xchg    ebx,SequenceX
        or      ebx,ebx
        jz      sData0

        push    esi
        push    edi
        push    ebp
        mov     ebp,esp
        mov     eax,[ebp+24]  ;dwLen
        or      eax,eax
        mov     ecx,eax
        jz      sData4

        add     eax,3
        mov     edi,esp
        and     eax,-4
        mov     esi,-4096
        mov     edx,esp
        sub     edi,eax
        and     edx,esi
        jmp short sData3

sData2: mov     [esp+esi],eax
        add     edx,esi
        add     esp,esi

sData3: cmp     edx,edi
        ja      sData2

        mov     esi,[ebp+28]  ;lpDat
        mov     esp,edi
        mov     eax,ecx
        rep     movsb

sData4: mov     ecx,ams.hRcvr
        push dword ptr [ebp+20]                  ;CopyDataHdr.dwCommand = dwCmd
        mov     edx,hWin
        push    ebx                              ;CopyDataHdr.nSequence
        add     eax,sizeof CopyDataHdr
        push    ecx                              ;CopyDataHdr.hRcvr
        push    edx                              ;CopyDataHdr.hXmtr
        push    esp                              ;COPYDATASTRUCT.lpData
        push    eax                              ;COPYDATASTRUCT.cbData
        push    ecx                              ;COPYDATASTRUCT.dwData
        INVOKE  SendMessage,ecx,WM_COPYDATA,edx,esp
        xor     edi,edi
        mov     esi,ebx
        mov     SequenceR,edi
        xchg    ebx,SeqFlush
        mov dword ptr cdTimeCnt,cdTIMEOUT        ;3000 = 15 seconds
        jmp short sData6

sData5: INVOKE  Sleep,5
        dec dword ptr cdTimeCnt
        jz      sData7

sData6: cmp     esi,SequenceR
        jnz     sData5

sDataX: inc     edi

sData7: leave

sData8: inc     esi
        jz      sData8

        xchg    eax,edi                          ;if EAX = 0, timeout occured
        xchg    esi,SequenceX
        pop     edi
        pop     esi
        pop     ebx
        ret     12

SndData ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

SndCtrl PROC    dwCmd:DWORD,nSeq:DWORD

;COPYDATASTRUCT STRUCT
; dwData    dd ?
; cbData    dd ?
; lpData    dd ?

;CopyDataHdr STRUCT
; hXmtr     dd ?
; hRcvr     dd ?
; nSequence dd ?
; dwCommand dd ?

        mov     ecx,ams.hRcvr
        push dword ptr [esp+4]                   ;CopyDataHdr.dwCommand = dwCmd
        mov     edx,hWin
        push dword ptr [esp+12]                  ;CopyDataHdr.nSequence
        push    ecx                              ;CopyDataHdr.hRcvr
        push    edx                              ;CopyDataHdr.hXmtr
        push    esp                              ;COPYDATASTRUCT.lpData
        push    sizeof CopyDataHdr               ;COPYDATASTRUCT.cbData
        push    ecx                              ;COPYDATASTRUCT.dwData
        INVOKE  SendMessage,ecx,WM_COPYDATA,edx,esp
        add     esp,28
        ret     8

SndCtrl ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

AckThrd PROC

;COPYDATASTRUCT STRUCT
; dwData    dd ?
; cbData    dd ?
; lpData    dd ?

;CopyDataHdr STRUCT
; hXmtr     dd ?
; hRcvr     dd ?
; nSequence dd ?
; dwCommand dd ?

        mov     ecx,ams.hRcvr
        push    dCU_ACKNOWLEDGE                  ;CopyDataHdr.dwCommand = dwCmd
        mov     edx,hWin
        push dword ptr [esp+8]                   ;CopyDataHdr.nSequence
        push    ecx                              ;CopyDataHdr.hRcvr
        push    edx                              ;CopyDataHdr.hXmtr
        push    esp                              ;COPYDATASTRUCT.lpData
        push    sizeof CopyDataHdr               ;COPYDATASTRUCT.cbData
        push    ecx                              ;COPYDATASTRUCT.dwData
        INVOKE  SendMessage,ecx,WM_COPYDATA,edx,esp
        add     esp,28
        INVOKE  ExitThread,0

AckThrd ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

SndAck  PROC    nSeq:DWORD

        xor     eax,eax
        INVOKE  CreateThread,eax,eax,AckThrd,[esp+12],eax,eax
        ret     4

SndAck  ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

pTxtOut PROC    lpString:LPSTR

pTxtO0: mov     eax,1
        xchg    al,rPSemaphore
        or      eax,eax
        jz      pTxtO1

        INVOKE  Sleep,eax
        jmp     pTxtO0

pTxtO1: INVOKE  CreateThread,eax,eax,PrnThrd,[esp+12],eax,eax
        ret     4

pTxtOut ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

PrnThrd PROC

        mov     esi,[esp+4]
        INVOKE  StrLen,esi
        inc     eax
        INVOKE  SndData,dCP_PRINT,eax,esi
        mov     al,0
        xchg    al,rPSemaphore
        INVOKE  ExitThread,0

PrnThrd ENDP

;*************************************************************************************************************

wrUpd   PROC

;This routine keeps the wr RECT structure updated with the most recent normalized window size.
;The height and width are calculated from wr RECT values and saved in the BIN (ini) file at exit.
;This function is disabled at the first sign of exit so that the RECT values are not destroyed.

        INVOKE  GetWindowRect,edx,offset wr

wrDis:: ret

wrUpd   ENDP

;*************************************************************************************************************

FontSize PROC

;Call With: EDX = selected font control ID number

        movzx   eax,word ptr FeList[edx-IDM_TEXT_SIZE]
        mov     SizeID,edx
        mov byte ptr cg.h.CellSize,ah
        mov byte ptr cg.v.CellSize,al
        ret

FontSize ENDP

;*************************************************************************************************************

SelectSize PROC

;Call With: EDX = selected font control ID number

        call    FontSize
        INVOKE  CheckMenuItem,hMenu,edx,MF_BYCOMMAND or MF_CHECKED
        ret

SelectSize ENDP

;*************************************************************************************************************

MakeFont PROC

;create a handle for the selected text size
;and calculate multiply-to-divide variables

        push    ebx
        call    M2dCalc
        mov     ebx,offset lf
        INVOKE  GetStockObject,OEM_FIXED_FONT
        INVOKE  GetObject,eax,sizeof LOGFONT,ebx
        mov     eax,cg.h.CellSize
        mov     ecx,cg.v.CellSize
        mov     [ebx].LOGFONT.lfWidth,eax
        mov     [ebx].LOGFONT.lfHeight,ecx
        INVOKE  CreateFontIndirect,ebx
        mov     hFont,eax
        pop     ebx
        ret

MakeFont ENDP

;*************************************************************************************************************

M2dCalc PROC

;calculate multiplier and shift values for multiply-to-divide
;input value are not validated
;tested for divisors 4-35 and dividends less than 80000000h

        mov     ebx,offset cg.h.CellSize
        call    MCalc0
        add     ebx,HvOfs

MCalc0: mov     eax,[ebx]
        dec     eax
        bsr     ecx,eax
        push    1
        inc     eax
        pop     edx
        mov     [ebx+8],ecx
        shl     edx,cl
        xchg    eax,ecx
        xor     eax,eax
        div     ecx
        inc     eax
        mov     [ebx+4],eax
        ret

M2dCalc ENDP

;*************************************************************************************************************

IsNotNormal PROC

;returns window state: normal, minimized, maximized
;
;  Returns: EAX = 0 if normal (ZF=1), 1 if minimized (ZF=0), 2 if maximized (ZF=0)
;           all other registers preserved

;            MaxFlag   MinFlag
;Normalized    hWin  client width
;Minimized     hWin       0
;Maximized      0    client width

        xor     eax,eax
        cmp     eax,MaxFlag
        adc     eax,eax
        cmp     eax,MinFlag
        rcl     eax,1
        xor     al,3
        ret

IsNotNormal ENDP

;*************************************************************************************************************

StMet   PROC

;get and store status bar height
;may also be used to get status bar position, as the pr RECT is filled

        INVOKE  GetWindowRect,hStatus,offset pr
        mov     edx,pr.top
        mov     eax,pr.bottom
        mov byte ptr StFlag,0
        sub     eax,edx
        mov     StbHeight,eax
        ret

StMet   ENDP

;*************************************************************************************************************

ScMet   PROC

;retrieves scroll bar sizes and calculates wheel divider constants
;
;uses EBX, ESI, EDI without preserving them

        push    SPI_GETWHEELSCROLLCHARS
        push    SM_CXVSCROLL
        mov     ebx,offset cg.h.BarSize
        pop     edi                                                 ;SM_CXVSCROLL = 2
        pop     esi                                                 ;SPI_GETWHEELSCROLLCHARS = 108
        call    ScMet0
        add     ebx,HvOfs
        inc     edi                                                 ;SM_CYHSCROLL = 3
        sub     esi,SPI_GETWHEELSCROLLCHARS-SPI_GETWHEELSCROLLLINES ;SPI_GETWHEELSCROLLLINES = 104

ScMet0: INVOKE  GetSystemMetrics,edi
        push    3                                                   ;default wheel step = 3
        mov     [ebx],eax                                           ;cg.h/v.BarSize
        mov     edx,esp
        INVOKE  SystemParametersInfo,esi,NULL,edx,NULL
        pop     ecx
        push    WHEEL_DELTA                                         ;WHEEL_DELTA = 120
        cmp     ecx,1
        pop     eax
        jbe     ScMet1

        xor     edx,edx
        div     ecx
        shl     edx,1
        cmp     edx,ecx
        cmc
        adc     eax,0

ScMet1: mov     [ebx+4],eax                                         ;cg.h/v.WheelDiv
        ret

ScMet   ENDP

;*************************************************************************************************************

WkMet   PROC

        sub     esp,16
        mov     eax,esp
        INVOKE  SystemParametersInfo,SPI_GETWORKAREA,NULL,eax,NULL
        pop     eax
        pop     ecx
        pop     edx
        sub     edx,eax
        pop     eax
        sub     eax,ecx
        mov     WrkWidth,edx
        mov     WrkHeight,eax
        ret

WkMet   ENDP

;*************************************************************************************************************

WrAdj   PROC

;Call With: EDX = hWin
;
;  Returns: EDX = hWin

        push    edi
        push    ebx
        push    esi
        push    TRUE                         ;MoveWindow:bRepaint
        sub     esp,16                       ;ScnMetric:RECT, MoveWindow:X,Y,nWidth,nHeight
        mov     edi,edx
        INVOKE  GetWindowRect,edx,esp
        push    WrkHeight                    ;ScnMetric:dwScnHeight
        push    WrkWidth                     ;ScnMetric:dwScnWidth
        CALL    ScnMetric                    ;screen metrics
        mov     WrFlag,ch
        jecxz   WrAdj1

        pop     eax
        pop     edx
        push    edi                          ;MoveWindow:hWnd
        CALL    MoveWindow

WrAdj0: mov     edx,edi
        pop     esi
        pop     ebx
        pop     edi
        ret

WrAdj1: add     esp,28
        jmp     WrAdj0

WrAdj   ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

ScnMetric PROC  dwScnWidth:DWORD,dwScnHeight:DWORD,dwLeft:DWORD,dwTop:DWORD,dwRight:DWORD,dwBottom:DWORD

        xor     ecx,ecx
        lea     ebx,[esp+12]       ;dwLeft
        call    SnMet0
        add     ebx,4              ;dwTop

SnMet0: mov     eax,[ebx+8]        ;EAX = dwRight or dwBottom
        mov     esi,[ebx]          ;ESI = dwLeft or dwTop
        mov     edx,[ebx-8]        ;EDX = dwScnWidth or dwScnHeight
        sub     eax,esi            ;EAX = window width or height
        cmp     eax,edx
        jbe     SnMet1

        inc     ecx
        mov     eax,edx

SnMet1: or      esi,esi
        mov     [ebx+8],eax        ;dwRight or dwBottom now = adjusted window width or height
        jns     SnMet2

        xor     esi,esi
        inc     ecx

SnMet2: add     eax,esi            ;EAX = window right or bottom
        sub     eax,edx
        jbe     SnMet3

        sub     esi,eax
        inc     ecx

SnMet3: mov     [ebx],esi
        ret

ScnMetric ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************
CcRst   PROC

;This routine copies the standard custom color set into either background or foreground color sets.
;EDI contains the address of the custom color structure to be updated.
;ESI is not preserved.

        push    16
        mov     esi,offset CustomColors
        pop     ecx
        rep     movsd
        ret

CcRst   ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

B2Hex   PROC    dwVal:DWORD,lpBuf:DWORD

        push    8
        mov     edx,[esp+12]             ;lpBuf
        pop     ecx
        mov     eax,[esp+4]              ;dwVal
        mov     [edx+ecx],ch
        dec     edx

B2Hex0: push    eax
        and     al,0Fh
        cmp     al,0Ah
        sbb     al,69h
        das                              ;0-9 > '0'-'9', 10-15 > 'A'-'F'
        mov     [edx+ecx],al
        pop     eax
        shr     eax,4
        dec     ecx
        jnz     B2Hex0

        ret     8

B2Hex   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

        ALIGN   16

TxtProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;WndProc routine for the text window

        mov     ecx,[esp+8]                                    ;uMsg
        cmp     ecx,WM_PAINT
        jnz     TxtPr0

;------------------------------------------------------------------------------

;WM_PAINT

;PAINTSTRUCT <>        ;(64 bytes)
; hdc         dd ?     ;[EBP]
; fErase      dd ?
; rcPaint     RECT <>
;   left        dd ?   ;[EBP+8]
;   top         dd ?   ;[EBP+12]
;   right       dd ?   ;[EBP+16]
;   bottom      dd ?   ;[EBP+20]
; fRestore    dd ?
; fIncUpdate  dd ?
; rgbReserved db 32 dup(?)

        push    ebp
        push    ebx
        push    esi
        push    edi
        sub     esp,64
        mov     ebp,esp
        INVOKE  BeginPaint,[ebp+84],esp
        mov     eax,cg.h.NewPos
        xor     ecx,ecx
        mov     edx,cg.v.NewPos
        cmp     eax,cg.h.CurPos
        jnz     Paint0

        cmp     edx,cg.v.CurPos
        jz      Paint1

Paint0: mov     edi,cg.v.s.nPage
        mov     cg.h.CurPos,eax
        mov     esi,ecx
        mov     cg.v.CurPos,edx
        push    edi
        push    cg.h.s.nPage
        push    esi
        push    ecx
        jmp short Paint2

Paint1: mov    edi,[ebp+20]                                    ;ps.rcPaint.bottom
        mov    esi,[ebp+12]                                    ;ps.rcPaint.top
        push   edi
        push dword ptr [ebp+16]                                ;ps.rcPaint.right
        push   esi
        push dword ptr [ebp+8]                                 ;ps.rcPaint.left

Paint2: INVOKE  pCalc,esi,edi,cg.v.Mult,cg.v.Shft,cg.v.CellSize,cg.v.CellsUsed,edx
        jz      Paint7

        INVOKE  pCalc,[ebp-16],[ebp-8],cg.h.Mult,cg.h.Shft,cg.h.CellSize,cg.h.CellsUsed,cg.h.CurPos
        jz      Paint7

        mov     eax,[ebp]                                      ;EAX = hdc
        push    hFont                                          ;SelectObject1:new font handle
        push    eax                                            ;SelectObject1:hdc
        push    TRANSPARENT                                    ;SetBkMode:iBkMode
        push    eax                                            ;SetBkMode:hdc
        push    vs.BackColor                                   ;SetBkColor:crColor
        push    eax                                            ;SetBkColor:hdc
        INVOKE  SetTextColor,eax,vs.ForeColor
        CALL    SetBkColor
        CALL    SetBkMode
        CALL    SelectObject
        xchg    eax,ecx
        mov     ebx,[ebp-40]                                   ;text row count
        mov     eax,RowLength
        mov     edi,[ebp-32]                                   ;vert adjusted start pixel
        push    eax                                            ;[EBP-76] = RowLength
        push    ecx                                            ;[EBP-80] = SelectObject2:old font handle

;-------

;[EBP+84] = hWnd = hTxt
;[EBP+20] = ps.rcPaint.bottom     paint structure
;[EBP+16] = ps.rcPaint.right            v v
;[EBP+12] = ps.rcPaint.top
; [EBP+8] = ps.rcPaint.left
; [EBP+4] = ps.fErase                   ^ ^
;   [EBP] = ps.hdc                paint structure, starting with hdc
; [EBP-4] = clip_rect.bottom
; [EBP-8] = clip_rect.right
;[EBP-12] = clip_rect.top
;[EBP-16] = clip_rect.left
;[EBP-20] = cg.v.CurPos/cg.v.NewPos
;[EBP-24] = cg.v.CellsUsed
;[EBP-28] = cg.v.CellSize
;[EBP-32] = vert adjusted start pixel
;[EBP-36] = vert start buffer row
;[EBP-40] = text row count
;[EBP-44] = clip_rect.top
;[EBP-48] = cg.h.CurPos/cg.h.NewPos
;[EBP-52] = cg.h.CellsUsed
;[EBP-56] = cg.h.CellSize
;[EBP-60] = horz adjusted start pixel
;[EBP-64] = horz start buffer char
;[EBP-68] = text column count
;[EBP-72] = clip_rect.left
;[EBP-76] = RowLength
;[EBP-80] = old font handle

;-------

        mul dword ptr [ebp-36]                                 ;vert start buffer row
        inc     ebx
        add     eax,BlockUsed
        mov     edx,[ebp-64]                                   ;horz start buffer char
        xchg    eax,esi
        mov     ecx,[ebp-68]                                   ;text column count
        jmp short Paint6

;-------

;EBX = text row count+1
;ECX = text column count
;EDX = horz start buffer char
;ESI = buffer row base pointer
;EDI = vert adjusted start pixel

Paint3: movzx   eax,word ptr [esi]
        push    ecx
        sub     eax,edx
        jbe     Paint5

        cmp     eax,ecx
        push    edx
        jbe     Paint4

        xchg    eax,ecx

Paint4: lea     edx,[esi+edx+2]
        lea     ecx,[ebp-16]                                   ;clip_rect
        INVOKE  ExtTextOut,[ebp],[ebp-60],edi,ETO_CLIPPED,ecx,edx,eax,NULL
        pop     edx

Paint5: add     esi,[ebp-76]                                   ;RowLength
        pop     ecx
        add     edi,[ebp-28]                                   ;cg.v.CellSize

Paint6: sub     ebx,1
        jnz     Paint3

;-------

        push dword ptr [ebp]                                   ;SelectObject2:hdc
        CALL    SelectObject

Paint7: mov     esp,ebp
        INVOKE  EndPaint,[ebp+84],ebp
        add     esp,64
        pop     edi
        pop     esi
        pop     ebx
        pop     ebp
        xor     eax,eax
        ret     16

;------------------------------------------------------------------------------

TxtPr0: cmp     ecx,WM_RBUTTONUP
        JNZ     DefWindowProc

;----------------------

;WM_RBUTTONUP

        push    ebp
        mov     ebp,esp
        xor     eax,eax
        mov     edx,[ebp+8]           ;hWnd
        push    eax                                                               ;TrackPopupMenu:prcRect
        movzx   ecx,word ptr [ebp+22] ;lParam high word
        push    edx                                                               ;TrackPopupMenu:hWnd
        push    eax                                                               ;TrackPopupMenu:nReserved
        movzx   eax,word ptr [ebp+20] ;lParam low word
        push    ecx                                                               ;TrackPopupMenu:y
        push    eax                                                               ;TrackPopupMenu:x
        INVOKE  ClientToScreen,edx,esp
        push    TPM_RETURNCMD or TPM_LEFTALIGN or TPM_TOPALIGN or TPM_NOANIMATION ;TrackPopupMenu:uFlags
        push    hEditMenu                                                         ;TrackPopupMenu:hMenu
        CALL    TrackPopupMenu
        jmp     TxPop                 ;in WndProc

TxtProc ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

        ALIGN   16

pCalc   PROC    p7:DWORD,p6:DWORD,p5:DWORD,p4:DWORD,p3:DWORD,p2:DWORD,p1:DWORD

;paint calculation routine
;this routine is called once for vertical calculations and once for horizontal
;
;parameters are not discarded at exit
;all registers may be used except EBP, which must be preserved
;
;retained input values            vertical                 horizontal
;
;p1 [EBP+32] buffer start         cg.v.CurPos/cg.v.NewPos  cg.h.CurPos/cg.h.NewPos
;p2 [EBP+28] buffer size          cg.v.CellsUsed           cg.h.CellsUsed
;p3 [EBP+24] cell size (divisor)  cg.v.CellSize            cg.h.CellSize
;
;discardable input values
;
;p4 [EBP+20] M2D shift            cg.v.Shft                cg.h.Shft
;p5 [EBP+16] M2D multiplier       cg.v.Mult                cg.h.Mult
;p6 [EBP+12] stop pixel           ps.rcPaint.bottom        ps.rcPaint.right
;p7 [EBP+8]  start pixel          ps.rcPaint.top           ps.rcPaint.left
;
;returned values
;
;p4 [EBP+20] adjusted start pixel
;p5 [EBP+16] start buffer char
;p6 [EBP+12] text char count

        push    ebp
        mov     ebp,esp
        mov     eax,[ebp+12] ;stop pixel
        mov     edi,[ebp+16] ;M2D multiplier
        sub     eax,2
        mov     ecx,[ebp+20] ;M2D shift
        jbe     pCalc3

        push    eax          ;dividend
        mul     edi
        mov     eax,[ebp+8]  ;start pixel
        shr     edx,cl
        sub     eax,1
        mov     esi,edx      ;quotient
        ja      pCalc0

        xor     eax,eax
        xor     ebx,ebx
        mov     edi,eax
        jmp short pCalc1

pCalc0: mov     ebx,eax      ;dividend
        mul     edi
        shr     edx,cl
        mov     eax,[ebp+24] ;cell size (divisor)
        mov     edi,edx      ;quotient
        mul     edx

pCalc1: pop     ecx
        inc     esi
        cmp     ecx,ebx
        jb      pCalc3

        sub     esi,edi
        jbe     pCalc3

        mov     ebx,[ebp+28] ;buffer size
        inc     eax
        add     edi,[ebp+32] ;buffer start
        mov     [ebp+20],eax ;adjusted start pixel
        sub     ebx,edi
        jbe     pCalc3

        cmp     esi,ebx
        jbe     pCalc2

        mov     esi,ebx

pCalc2: mov     [ebp+16],edi ;start buffer char
        or      esi,esi
        mov     [ebp+12],esi ;text char count
        pop     ebp
        ret

pCalc3: cmp     esi,esi
        pop     ebp
        ret

pCalc   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

TestComplete PROC

;displays "Test Complete at hh:mm:ss" message in the status bar
;also, enables File/Save As, and clipboard copy menu items
;these menu items are disabled at program initialization

        pushad
        mov     eax,esp
        INVOKE  GetTimeFormat,LOCALE_USER_DEFAULT,
                TIME_FORCE24HOURFORMAT or TIME_NOTIMEMARKER,NULL,NULL,eax,32
        push    ' ta '
        push    'etel'
        push    'pmoC'
        push    ' tse'
        push    'T   '
        lea     eax,[esp+2]
        INVOKE  SendMessage,hStatus,SB_SETTEXT,0,eax
        add     esp,52

;*******************************************************

;enables File/Save As, and clipboard copy menu items
;these menu items are disabled at program initialization

TextReady::
        push    IDM_FILE_SAVEAS
        push    IDM_EDIT_COPYFORUM
        push    IDM_EDIT_COPYALL
        push    3
        pop     ecx

Cmplt0: pop     eax
        push    ecx
        INVOKE  EnableMenuItem,hMenu,eax,MF_BYCOMMAND or MF_ENABLED
        pop     ecx
        loop    Cmplt0

        ret

TestComplete ENDP

;*************************************************************************************************************

dNewLine PROC

;dNewLine is equiv to CR/LF
;NextLine is equiv to LF

        mov dword ptr LocCntX,0

;*******************************************************

NextLine::
        mov     eax,LocCntY
        mov     edx,BufCalc2                     ;BufferRows-1
        inc     eax
        cmp     eax,edx
        ja      NLine0

        mov     LocCntY,eax
        jmp short NLine2

NLine0: mov     LocCntY,edx
        push    edi
        mov     ecx,BufCalc3                     ;RowLength*(BufferRows-1)/4
        mov     edi,BlockUsed
        push    esi
        movzx   eax,word ptr [edi]
        mov     dl,0Bh
        cmp     eax,cg.h.CellsUsed
        mov     esi,SecondRowAddr
        jb      NLine1

        or      edx,4

NLine1: rep     movsd
        xor     eax,eax
        mov     ecx,BufCalc1                     ;RowLength/4
        or      dUpdateFlags,dl
        rep     stosd
        pop     esi
        pop     edi

NLine2: mov     al,DMODE_NEWLINE

;*******************************************************

mcUpdate::

;Mode Controlled Display Update

;DMODE_NEWLINE      EQU 1                                      ;new line display update mode bit
;DMODE_CLEARLINE    EQU 2                                      ;clear line display update mode bit
;DMODE_TEXTOUT      EQU 4                                      ;text out display update mode bit

        test    al,dUpdateMode
        jnz     dUpdate

        movzx   eax,byte ptr sUpdateEnable
        mov     sUpdateEnable,ah
        push    eax
        call    dUpdate
        pop     eax
        mov     sUpdateEnable,al
        ret

dNewLine ENDP

;*************************************************************************************************************

ChangeMode PROC

;Change Display Control Mode

;DMODE_MANUAL       EQU 0                                      ;manual display update mode
;DMODE_SEMI_AUTO    EQU DMODE_NEWLINE or DMODE_CLEARLINE       ;semi-auto display update mode
;DMODE_FULL_AUTO    EQU DMODE_SEMI_AUTO or DMODE_TEXTOUT       ;full-auto display update mode
;DMODE_FORCE_UPDATE EQU 100h                                   ;force update on mode change
;
;DMODE_MASK         EQU DMODE_FULL_AUTO or DMODE_FORCE_UPDATE  ;test mask

        movzx   ecx,byte ptr dUpdateMode
        and     eax,DMODE_MASK
        not     ecx
        mov     dUpdateMode,al
        test    eax,ecx
        jnz     dUpdate

        ret

ChangeMode ENDP

;*************************************************************************************************************

dUpdate PROC

;dUpdateFlags:
;bit 0 = display update required
;bit 1 = TextCalc required
;bit 2 = cg.h.CellsUsed update required (naturally performs cg.v.CellsUsed update)
;bit 3 = cg.v.CellsUsed update required

;----------------------

;buffer metrics update

        movzx   ecx,byte ptr dUpdateFlags
        xor     edx,edx
        test    ecx,0Ch
        jz      dUpdt5

        push    esi
        mov     eax,edx
        push    edi
        mov     esi,LastRowAddr
        push    ebp
        mov     edi,BufferRows
        push    ebx
        mov     ebp,RowLength

dUpdt0: or      eax,eax
        movzx   ebx,word ptr [esi]
        jnz     dUpdt1

        or      ebx,ebx
        jz      dUpdt2

        test    ecx,4                  ;cg.h.CellsUsed upd req'd ?
        mov     eax,edi
        jz      dUpdt4                 ;no - exit loop

dUpdt1: cmp     ebx,edx
        jbe     dUpdt2

        mov     edx,ebx

dUpdt2: sub     esi,ebp
        dec     edi
        jnz     dUpdt0

        or      edx,edx
        jnz     dUpdt3

        inc     edx

dUpdt3: or      eax,eax
        mov     cg.h.CellsUsed,edx
        jnz     dUpdt4

        inc     eax

dUpdt4: pop     ebx
        pop     ebp
        mov     cg.v.CellsUsed,eax
        pop     edi
        pop     esi

dUpdt5: cmp     ecx,1
        jz      dUpdt6

        jb      sUpdt2

        push    1
        call    TextCalc
        pop     ecx

dUpdt6: cmp     ch,sUpdateEnable
        jz      sUpdt1

;*******************************************************

;screen update

sUpdate::
        call    CtlUpdate
        or      eax,eax
        jnz     sUpdt0

        INVOKE  InvalidateRgn,hTxt,eax,TRUE

sUpdt0: xor     ecx,ecx

sUpdt1: mov     dUpdateFlags,cl

sUpdt2: ret

dUpdate ENDP

;*************************************************************************************************************

TextCalc PROC

;TextCalc must be called whenever the client area data pixel size changes
;this includes changing the client area text data or resizing the font

;Returns: EDX = 0
;         ECX preserved

        push    ebx
        mov     ebx,offset cg
        mov     eax,[ebx].CoordinateGroup.h.CellsUsed
        mov     edx,[ebx].CoordinateGroup.h.CellSize
        inc     eax
        mul     edx
        inc     eax
        mov     [ebx].CoordinateGroup.h.s.nMax,eax
        mov     eax,[ebx].CoordinateGroup.v.CellsUsed
        mov     edx,[ebx].CoordinateGroup.v.CellSize
        inc     eax
        mul     edx
        inc     eax
        mov     [ebx].CoordinateGroup.v.s.nMax,eax
        pop     ebx
        ret

TextCalc ENDP

;*************************************************************************************************************

dClrLine PROC USES EBX nColumn:DWORD,nRow:DWORD

;clear buffer line from specified position to end of line
;
;1) from nColumn,nRow, clear to end of line
;2) from nColumn-1,nRow, seek backward to find last visible char
;   of course, if nColumn = 0, this is not necessary
;3) adjust row length value to reflect that length
;4) set a flag if it was longer than any current row
;   this flag will be -1 if another row is as long or longer than the previous row length
;   otherwise, it will be the length of the longest row
;
;note: this function does not alter the location counters

        mov     eax,nRow
        mov     ecx,nColumn
        cmp     eax,BufferRows
        jae     CLine2

        cmp     ecx,BufferColumns
        jae     CLine2

        mov     ebx,ecx
        mul dword ptr RowLength
        neg     ecx
        add     eax,BlockUsed
        movzx   edx,word ptr [eax]
        add     ecx,edx
        jae     CLine2

        mov     [eax],bx
        push    edi
        xchg    eax,edi
        add     edi,ebx
        xor     eax,eax
        add     edi,2
        rep     stosb
        inc     eax                  ;display update required
        cmp     edx,cg.h.CellsUsed
        pop     edi
        jb      CLine0

        mov     al,7
        jmp short CLine1

CLine0: or      ebx,ebx
        mov     ecx,nRow
        jnz     CLine1

        cmp     ecx,cg.v.CellsUsed
        jb      CLine1

        mov     al,0Bh

CLine1: or byte ptr dUpdateFlags,al
        mov     al,DMODE_CLEARLINE
        call    mcUpdate

CLine2: ret

dClrLine ENDP

;*************************************************************************************************************

StrScan PROC

;scan a text string and return the number of characters preceeding the first "special" character
;special characters include 0,9,10,12,13
;
;Call With: ESI = offset of string
;
;  Returns: EAX = bytes preceeding special char
;           EDX = special char identifier:
;                 0 (12) form feed (used to clear screen)
;                 4 (0) null terminator
;                 5 (9) tab
;                 6 (13) carriage return
;                 7 (10) line feed
;           ZF  = set if EAX = 0, otherwise cleared

        or      ecx,-1
        mov     ebx,7F7F7F7Fh
        push    esi
        mov     edi,9090909h
        xor     ebp,ebp

sScan0: push    edi
        mov     eax,[esi]
        push    ecx
        dec     ebp
        push    5050505h
        mov     ecx,5
        jmp short sScan2

sScan1: pop     edx
        xor     eax,edi
        xor     edi,edx
        ror     ebp,1
        sub     edx,2020202h
        and     edi,7070707h
        push    edx

sScan2: mov     edx,eax
        and     edx,ebx
        add     edx,ebx
        or      edx,eax
        or      edx,ebx
        and     ebp,edx
        dec     ecx
        jnz     sScan1

        pop     edx
        pop     ecx
        add     esi,4
        inc     ecx
        inc     ebp
        pop     edi
        jz      sScan0

        bsf     eax,ebp
        shl     ecx,2
        lea     edx,[eax+1]
        pop     esi
        shr     eax,3
        and     edx,7
        add     eax,ecx
        ret

StrScan ENDP

;*************************************************************************************************************

Justify PROC

;justify the location counter values to insure they are valid

        mov     eax,BufferColumns
        mov     edx,BufCalc2                ;BufferRows-1
        cmp     eax,LocCntX
        jae     Justf0

        mov     LocCntX,eax

Justf0: cmp     edx,LocCntY
        jae     Justf1

        mov     LocCntY,edx

Justf1: ret

Justify ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

dTxtOut PROC    lpTxt:DWORD

;intended to more-or-less emulate the console StdOut function
;some elements of behaviour mock that of the console - others mock that of a text editor like notepad
;
; 1) The FormFeed character (12) may be used to clear the screen.
; 2) The Bell character (7) is not expanded to a sound; It is a visible character.
; 3) Tabs are expanded to spaces that overwrite existing text, similar to the console.
;    Text editors simply move the cursor or, perhaps, insert spaces.
; 4) Spaces (32) at the end of a line count as visible; Nulls (0) do not.
;    This primarily affects scrollbar behaviour, which is similar to a text editor.
; 5) Because Nulls are used as string terminators, there is no convenient way to clear an area.
;    For this reason, a ClearLine function is provided that will clear to end-of-line from a given position.
;    The ClearLine function does not alter the location counters.
; 6) The dTxtOut function line-wraps and updates location counters, similar to a console.
;    However, I never liked the way the console (or VT-100) handled line-wrap and CR/LF.
;    Therefore, the X location counter has special properties:
;   a) We allow the X location to be equal to the row length (normally, the max is row length - 1).
;      This indicates that the last char on the line has been written, and no more.
;   b) If the current X location is equal to the row length:
;      1) If the buffer location is calculated to stream the next visible char, a NextLine is generated.
;      2) CarriageReturn and LineFeed behave as desired, without inserting extra blank lines.
;      3) A NextLine is generated prior to expanding a Tab.
;   c) Care must be taken if retrieving the current location.
;      The caller must be aware of the maximum valid X position.
; 7) When a line feed is streamed in a console window, the viewable portion is scrolled so
;    that the last line is visible. This behaviour can be irritating if you are trying to view
;    older screen text. In this implementation, a single line is scrolled, instead. This permits
;    the viewing of older text while still letting the viewer know that an update has occured.
; 8) Unlike the console, all text uses the same 2 colours; foreground and background.
;    This version does not implement character attributes.

;----------------------

;prologue

        push    esi
        call    Justify
        push    ebx
        mov     esi,[esp+12]
        push    edi
        dec     esi
        push    ebp

;----------------------

;string scan

dTxtO0: inc     esi
        call    StrScan
        jz      dTxtOC

        or      edx,edx
        jz      dTxtOD

dTxtO1: push    edx

;----------------------

;output to buffer

        mov     ebp,LocCntX
        mov     ebx,BufferColumns
        sub     ebx,ebp
        jnz     dTxtO3

        xchg    ebx,ebp

dTxtO2: push    eax
        push    edx
        call    dNewLine
        pop     edx
        pop     eax

dTxtO3: cmp     edx,8
        mov     edi,RowLength
        mov     ecx,LocCntY
        jnz     dTxtO5

        cmp     dh,BufDisable
        jnz     dTxtO4

        mov     eax,ebp
        and     eax,7
        neg     eax
        add     eax,edx
        cmp     eax,ebx
        jbe     dTxtO6

        mov     eax,ebx
        jmp short dTxtO6

dTxtO4: pop     edx
        pop     eax
        pop     eax
        pop     esi
        jmp     dTxtOJ

dTxtO5: cmp     dh,BufDisable
        jz      dTxtO6

        pop     edx
        jmp     dTxtOJ

dTxtO6: imul    edi,ecx
        mov     dl,dh
        add     edi,BlockUsed
        cmp     ecx,cg.v.CellsUsed
        jb      dTxtO8

        inc     ecx
        or byte ptr dUpdateFlags,3
        cmp     dx,[edi]
        mov     cg.v.CellsUsed,ecx
        mov     edx,cg.v.NewPos
        jnz     dTxtO8

        cmp     edx,cg.v.CurPos
        jnz     dTxtO8

        push    ebx
        sub     ecx,edx
        mov     ebx,cg.v.CellSize
        imul    ecx,ebx
        cmp     ecx,tr.bottom
        jb      dTxtO7

        inc     edx
        mov     cg.v.NewPos,edx
        imul    ebx,edx
        mov     cg.v.s.nPos,ebx

dTxtO7: pop     ebx

dTxtO8: add     edi,2
        mov     ecx,ebx
        push    edi
        add     edi,ebp
        cmp     eax,ebx
        jae     dTxtO9

        mov     ecx,eax
        mov     ebx,eax

dTxtO9: rep     movsb
        add     ebp,ebx
        pop     edi
        mov     LocCntX,ebp
        mov     edx,edi
        mov     ebp,BufferColumns
        add     edx,ebp

dTxtOA: dec     edx
        cmp     cl,[edx]
        jz      dTxtOA

        inc     edx
        inc     ecx
        sub     edx,edi
        cmp     edx,cg.h.CellsUsed
        mov     [edi-2],dx
        jbe     dTxtOB

        or      ecx,2
        mov     cg.h.CellsUsed,edx

dTxtOB: or      dUpdateFlags,cl
        sub     eax,ebx
        push    0
        mov     ebx,ebp
        pop     ebp
        jnz     dTxtO2

;----------------------

;special char dispatch

        pop     edx

dTxtOC: or      edx,edx                  ;form feed
        jz      dTxtOE

        sub     edx,8                    ;tab complete
        jz      dTxtOF

        inc     edx                      ;line feed
        jz      dTxtOG

        inc     edx                      ;carriage return
        jz      dTxtOH

        inc     edx                      ;tab
        jnz     dTxtOI                   ;otherwise, it's the null terminator

;----------------------

;special char = tab

        mov     eax,20202020h
        push    esi
        push    eax
        push    eax
        mov     edx,8                    ;special char indicator = tab complete
        mov     esi,esp
        jmp     dTxtO1

;----------------------

;special char = form feed (clear screen)

dTxtOD: add     esi,eax

dTxtOE: mov     edi,BlockUsed
        xchg    eax,edx
        mov     ecx,BufCalc4             ;RowLength*BufferRows/4
        mov     LocCntX,eax
        rep     stosd
        mov     LocCntY,eax
        or byte ptr dUpdateFlags,7
        jmp     dTxtO0

;----------------------

;special char = tab complete

dTxtOF: pop     eax
        pop     edx
        pop     esi
        jmp     dTxtO0

;----------------------

;special char = line feed

dTxtOG: call    NextLine
        jmp     dTxtO0

;----------------------

;special char = carriage return

dTxtOH: mov     LocCntX,edx
        jmp     dTxtO0

;----------------------

;display update

;EAX = 0

dTxtOI: mov     al,DMODE_TEXTOUT
        call    mcUpdate

;----------------------

;epilogue

dTxtOJ: pop     ebp
        xchg    eax,esi
        pop     edi
        pop     ebx
        sub     eax,[esp+8]
        pop     esi
        ret     4

dTxtOut ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

ScnLen  PROC

;returns the length of all text in the buffer, adding CR/LF's to the count
;used for file save and copy to clipboard functions

;  Returns: EAX = byte count, including CR/LF's
;           ECX = used row count
;           EDX = BlockUsed

        push    edi
        xor     eax,eax
        mov     ecx,BufferRows
        mov     edx,LastRowAddr
        mov     edi,RowLength

ScLen0: cmp     ax,[edx]
        jnz     ScLen1

        sub     edx,edi
        dec     ecx
        jnz     ScLen0

        jmp short ScLen3

ScLen1: push    ebx
        push    ecx

ScLen2: movzx   ebx,word ptr [edx]
        sub     edx,edi
        add     eax,ebx
        dec     ecx
        jnz     ScLen2

        pop     ecx
        pop     ebx
        add     eax,ecx

ScLen3: add     edx,edi
        add     eax,ecx
        pop     edi
        ret

ScnLen  ENDP

;*************************************************************************************************************

Scn2File PROC

;convert the screen buffer to file save format

;Call With: EAX = buffer address
;           ECX = row count
;           EDX = BlockUsed
;
;  Returns: EAX = address of next byte in buffer
;           ECX = bytes written to buffer
;           EDX = buffer address

        push    ebx
        push    eax
        mov     bh,20h

S2Fil0: push    ecx
        push    edx
        movzx   ecx,word ptr [edx]
        inc     edx
        inc     edx

S2Fil1: mov     bl,[edx]
        or      bl,bl
        jnz     S2Fil2

        mov     bl,bh

S2Fil2: mov     [eax],bl
        inc     edx
        inc     eax
        dec     ecx
        jnz     S2Fil1

        mov word ptr [eax],0A0Dh
        pop     edx
        inc     eax
        pop     ecx
        inc     eax
        add     edx,RowLength
        dec     ecx
        jnz     S2Fil0

        pop     edx
        mov     ecx,eax
        pop     ebx
        sub     ecx,edx
        ret

Scn2File ENDP

;*************************************************************************************************************

CbCopy  PROC    USES EBX ESI EDI dwMode:DWORD

;copy the conents of the screen buffer to the clipboard
;the optional forum [code] and [/code] tags may be added

        INVOKE  OpenClipboard,hWin
        or      eax,eax
        jz      CCopy4

        xor     esi,esi
        INVOKE  EmptyClipboard
        inc     esi
        or      eax,eax
        jz      CCopy3

        call    ScnLen
        mov     ebx,ecx
        add     eax,dwMode
        mov     edi,edx
        INVOKE  GlobalAlloc,GMEM_MOVEABLE or GMEM_DDESHARE,eax
        or      eax,eax
        jz      CCopy3

        push    eax
        INVOKE  GlobalLock,eax
        mov     ecx,ebx
        mov     edx,edi
        cmp byte ptr dwMode,COPY_MODE
        pop     ebx
        mov     edi,esi
        jz      CCopy0

        mov dword ptr [eax],'doc['
        mov word ptr [eax+4],']e'
        dec     edi
        add     eax,6

CCopy0: call    Scn2File
        xor     edx,edx
        dec     edi
        jz      CCopy1

        mov dword ptr [eax-2],'oc/['
        mov     edx,']ed'
        inc     eax
        inc     eax

CCopy1: mov     [eax],edx
        INVOKE  GlobalUnlock,ebx
        INVOKE  SetClipboardData,CF_OEMTEXT,ebx
        or      eax,eax
        jz      CCopy2

        dec     esi

CCopy2: INVOKE  GlobalFree,ebx

CCopy3: INVOKE  CloseClipboard
        dec     esi
        jnz     CCopy5

CCopy4: INVOKE  MessageBox,hWin,offset CbErrText,offset CbErrTitle,MB_ICONERROR

CCopy5: ret

CbCopy  ENDP

;*************************************************************************************************************

FSaveAs PROC

;File Save As dialog

;OPENFILENAME STRUCT
; lStructSize       dd ?
; hwndOwner         dd ?
; hInstance         dd ?
; lpstrFilter       dd ?
; lpstrCustomFilter dd ?
; nMaxCustFilter    dd ?
; nFilterIndex      dd ?
; lpstrFile         dd ?
; nMaxFile          dd ?
; lpstrFileTitle    dd ?
; nMaxFileTitle     dd ?
; lpstrInitialDir   dd ?
; lpstrTitle        dd ?
; Flags             dd ?
; nFileOffset       dw ?
; nFileExtension    dw ?
; lpstrDefExt       dd ?
; lCustData         dd ?
; lpfnHook          dd ?
; lpTemplateName    dd ?

        call    FnAlloc
        push    eax                                                      ;HFree:hBlck
        push    edx
        push    eax
        push    ecx                                                      ;lpTemplateName
        dec     edx
        push    ecx                                                      ;lpfnHook
        push    ecx                                                      ;lCustData
        push    offset FileTypeStrs+13                                   ;lpstrDefExt - 'txt',0
        push    ecx                                                      ;nFileOffset/nFileExtension
        push    OFN_LONGNAMES or OFN_HIDEREADONLY or OFN_OVERWRITEPROMPT ;Flags or OFN_ENABLEHOOK or OFN_EXPLORER
        push    offset szSaveAs                                          ;lpstrTitle
        push    ecx                                                      ;lpstrInitialDir
        push    ecx                                                      ;nMaxFileTitle
        push    ecx                                                      ;lpstrFileTitle
        push    edx                                                      ;nMaxFile
        push    eax                                                      ;lpstrFile
        push    1                                                        ;nFilterIndex
        push    ecx                                                      ;nMaxCustFilter
        push    ecx                                                      ;lpstrCustomFilter
        push    offset FileTypeStrs                                      ;lpstrFilter
        push    hInstance                                                ;hInstance
        push    ecx                                                      ;hwndOwner
        push    76                                                       ;lStructSize
        INVOKE  GetSaveFileName,esp
        add     esp,76                                                   ;sizeof OPENFILENAME
        xor     eax,eax
        pop     edx
        pop     ecx
        cmp     al,[edx]
        jz      FSave6

        mov     edi,edx
        inc     ecx
        repnz   scasb
        sub     edi,5
        cmp dword ptr [edi],'txt.'
        jnz     FSave2

        lea     esi,[edi-1]

FSave0: mov     cl,[esi]
        cmp     cl,'.'
        jz      FSave1

        cmp     cl,'\'
        jz      FSave2

        cmp     cl,':'
        jz      FSave2

        dec     esi
        cmp     esi,edx
        ja      FSave0

        jmp short FSave2

FSave1: mov     [edi],al

FSave2: mov     edi,edx
        call    ScnLen
        push    ecx
        add     eax,16
        push    edx
        INVOKE  HeapAlloc,hHeap,NULL,eax
        pop     edx
        or      eax,eax
        pop     ecx
        jz      FSave5

        xor     esi,esi
        call    Scn2File
        push    ecx
        push    edx
        INVOKE  OpnFile,edi,FILECREATE
        inc     esi
        pop     edx
        inc     eax
        pop     ecx
        jz      FSave4

        dec     eax
        push    edx
        dec     esi
        push    eax
        push    ecx
        push    esi
        mov     ebx,esp
        INVOKE  WriteFile,eax,edx,ecx,ebx,esi
        pop     esi
        pop     ecx
        pop     ebx
        sub     esi,ecx
        or      eax,eax
        jnz     FSave3

        xchg    eax,esi
        inc     esi

FSave3: INVOKE  CloseHandle,ebx
        pop     edx

FSave4: INVOKE  HFree,edx
        dec     esi
        jnz     FSave6

FSave5: INVOKE  MessageBox,hWin,offset FileErrText,offset FileErrTitle,MB_ICONERROR

FSave6: CALL    HFree
        mov     edx,offset FSSemaphore
        mov     eax,IDM_FILE_SAVEAS
        jmp     ThreadExit

FSaveAs ENDP

;*************************************************************************************************************

CColor  PROC

;color chooser dialog
;used for both foreground and background

;CHOOSECOLOR STRUCT
; lStructSize      dd ?
; hwndOwner        dd ?
; hInstance        dd ?
; rgbResult        dd ?
; lpCustColors     dd ?
; Flags            dd ?
; lCustData        dd ?
; lpfnHook         dd ?
; lpTemplateName   dd ?

        mov     eax,IDM_BACK_COLOR
        cmp     eax,CCMode
        jnz     CColr0

        mov     eax,IDM_FORE_COLOR

CColr0: push    eax
        INVOKE  EnableMenuItem,hMenu,eax,MF_BYCOMMAND or MF_GRAYED
        pop     eax
        mov     edx,offset vs.BackColor
        cmp     eax,IDM_BACK_COLOR
        mov     ecx,offset CustomBack
        jnz     CColr1

        add     edx,4 ;(structure)
        add     ecx,64 ;(structure)

CColr1: xor     eax,eax
        push    edx                                       ;color pointer
        push    eax                                       ;lpTemplateName
        push    eax                                       ;lpfnHook
        push    eax                                       ;lCustData
        push    CC_ANYCOLOR or CC_FULLOPEN or CC_RGBINIT  ;Flags
        push    ecx                                       ;lpCustColors
        push dword ptr [edx]                              ;rgbResult
        push    eax                                       ;hInstance
        push    eax                                       ;hwndOwner
        push    sizeof CHOOSECOLOR                        ;lStructSize
        INVOKE  ChooseColor,esp
        mov     ecx,[esp+12]                              ;rgbResult
        add     esp,sizeof CHOOSECOLOR
        pop     edx                                       ;color pointer
        or      eax,eax
        jz      CColr3

        mov     [edx],ecx
        cmp dword ptr CCMode,IDM_BACK_COLOR
        jnz     CColr2

        INVOKE  CreateSolidBrush,ecx
        INVOKE  SetClassLong,hTxt,GCL_HBRBACKGROUND,eax   ;hBrush
        INVOKE  DeleteObject,eax                          ;delete old brush

CColr2: INVOKE  InvalidateRgn,hTxt,NULL,TRUE

CColr3: INVOKE  EnableMenuItem,hMenu,IDM_FORE_COLOR,MF_BYCOMMAND or MF_ENABLED
        mov     edx,offset CCSemaphore
        mov     eax,IDM_BACK_COLOR
        jmp short ThreadExit

CColor  ENDP

;*************************************************************************************************************

HHelp   PROC

;help dialog

        INVOKE  MessageBox,NULL,offset HelpText,ams.AppNamePtr,MB_ICONQUESTION
        mov     edx,offset HHSemaphore
        mov     eax,IDM_HELP_HELP
        jmp short ThreadExit

HHelp   ENDP

;*************************************************************************************************************

HAbout  PROC

;help-about dialog

        INVOKE  ShellAbout,NULL,offset NullStr,offset AboutText,hIcon
        mov     edx,offset HASemaphore
        mov     eax,IDM_HELP_ABOUT

;*******************************************************

ThreadExit::
        push    1
        push    edx
        INVOKE  EnableMenuItem,hMenu,eax,MF_BYCOMMAND or MF_ENABLED
        pop     edx
        pop     eax
        xchg    al,[edx]
        INVOKE  ExitThread,eax

HAbout  ENDP

;*************************************************************************************************************

DlgThread PROC  lpProc:DWORD,lpSemaphore:DWORD,dwCtlID:DWORD

;creates a thread for file save, color chooser, help, help-about

        mov     edx,lpSemaphore
        xor     ecx,ecx
        xchg    cl,[edx]
        jecxz   DlgTh2

        mov     eax,dwCtlID
        cmp     eax,IDM_FORE_COLOR
        jz      DlgTh0

        cmp     eax,IDM_BACK_COLOR
        jnz     DlgTh1

DlgTh0: mov     CCMode,eax

DlgTh1: INVOKE  EnableMenuItem,hMenu,eax,MF_BYCOMMAND or MF_DISABLED
        xor     eax,eax
        INVOKE  CreateThread,eax,eax,lpProc,eax,eax,eax

DlgTh2: ret

DlgThread ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

OpnFile PROC    lpFileName:DWORD,dwOpenFlags:DWORD

;file open function

;FILECREATE EQU GENERIC_WRITE or CREATE_ALWAYS
;FILEREAD   EQU GENERIC_READ or OPEN_EXISTING

        mov     eax,[esp+8]
        xor     ecx,ecx
        mov     edx,eax
        and     edx,0F0000000h
        and     eax,3
        INVOKE  CreateFile,[esp+28],edx,FILE_SHARE_READ,
                ecx,eax,FILE_ATTRIBUTE_NORMAL,ecx
        ret     8

OpnFile ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

GetExePath PROC

;Gets the full path of the currently running program.
;The 'filename.exe' portion of the string is removed, leaving just the path.
;The allocated buffer must be free'd when done.
;
;  Returns: EAX = address of heap allocated pathname (must be freed)
;           ECX = pathname length
;           EDX = heap allocated buffer size

        call    FnAlloc
        push    edx
        push    eax
        dec     edx
        push    eax
        INVOKE  GetModuleFileName,ecx,eax,edx
        xchg    eax,ecx
        pop     edx
        mov     eax,3A5Ch         ;'\:'
        add     edx,ecx
        inc     ecx

EPath0: dec     ecx
        jz      EPath2

        dec     edx
        cmp     al,[edx]
        jz      EPath1

        cmp     ah,[edx]
        jnz     EPath0

EPath1: inc     edx

EPath2: mov byte ptr [edx],0
        pop     eax
        pop     edx
        ret

GetExePath ENDP

;*************************************************************************************************************

MakeIFn PROC

;creates BIN (ini) file name in heap-allocated buffer

;  Returns: EAX = address of heap allocated path/file name (must be freed)
;           ECX = address of 'dTest.bin' string
;           EDX = address of small file buffer (above filename string)

        call    GetExePath
        add     ecx,eax
        mov dword ptr [ecx],'seTd'
        mov     edx,ecx
        mov dword ptr [ecx+4],'ib.t'
        add     edx,13
        mov word ptr [ecx+8],'n'
        and     edx,-4
        ret

MakeIFn ENDP

;*************************************************************************************************************

FnAlloc PROC

;allocate temporary buffer for filenames

;  Returns: EAX = address of allocated block
;           ECX = 0
;           EDX = size of allocated block

        mov     edx,4096
        push    edx
        INVOKE  HeapAlloc,hHeap,HEAP_ZERO_MEMORY,edx
        xor     ecx,ecx
        pop     edx
        ret

FnAlloc ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

HFree   PROC    hBlck:DWORD

;frees heap allocation

        pop     edx
        push    NULL
        push    hHeap
        push    edx
        JMP     HeapFree

HFree   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

dWinExit PROC

;## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##

;test code

        xor     eax,eax
        cmp     eax,thrd_ctrl
        jz      skip_thrd

        xchg    al,thrdend
        mov     al,ah

loop00: cmp     al,thrdended
        jnz     loop00

skip_thrd:

;## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##

;ssf SavedSettingsFile <>
; szMarker         db 10 dup(?) ;'dTest.bin',0
; wFileSize        dw ?         ;120
; wWindowWidth     dw ?
; wWindowHeight    dw ?
; wFlagsTextSize   dw ?
; rgbBackColor     db 3 dup(?)
; rgbForeColor     db 3 dup(?)
; rgbCustomBack    db 48 dup(?)
; rgbCustomFore    db 48 dup(?)

;wFlagsTextSize bits:
;
;bit(s)  description
; 0-4     text size cell height - 4
;  5      maximized flag
;  6      status bar flag
;  7      shift-vertical mouse wheel flag
; 8-12    text size cell width - 4
; 13      ctrl-vertical mouse wheel flag
; 14      horizontal mouse wheel flag
; 15      shift-horizontal mouse wheel flag

        INVOKE  DeleteObject,hFont
        call    MakeIFn
        push    eax                                  ;HFree:hBlck
        mov     esi,ecx
        mov     edi,edx
        movsd                                        ;SavedSettingsFile.szMarker
        movsd
        movsw
        mov     eax,sizeof SavedSettingsFile         ;120
        stosw                                        ;SavedSettingsFile.wFilesize
        mov     eax,wr.right
        sub     eax,wr.left
        stosw                                        ;SavedSettingsFile.wWindowWidth
        mov     eax,wr.bottom
        sub     eax,wr.top
        stosw                                        ;SavedSettingsFile.wWindowHeight
        mov     eax,cg.v.CellSize
        mov     ah,byte ptr cg.h.CellSize
        sub     eax,404h
        cmp dword ptr MaxFlag,0
        jnz     IFile0

        or      eax,20h

IFile0: mov     ecx,StbState
        shl     ecx,3
        or      eax,ecx
        mov     ecx,ShftVrtState
        shl     ecx,4
        or      eax,ecx
        mov     ecx,CtrlVrtState
        shl     ecx,10
        or      eax,ecx
        mov     ecx,HrzState
        shl     ecx,11
        or      eax,ecx
        mov     ecx,ShftHrzState
        shl     ecx,12
        or      eax,ecx
        stosw                                        ;SavedSettingsFile.wFlagsTextSize
        mov     eax,vs.BackColor
        stosd                                        ;SavedSettingsFile.rgbBackColor
        dec     edi
        mov     eax,vs.ForeColor
        stosd                                        ;SavedSettingsFile.rgbForeColor
        push    32
        dec     edi
        mov     esi,offset CustomBack ;(structure)
        pop     ecx

IFile1: movsd                                        ;SavedSettingsFile.rgbCustomBack, rgbCustomFore
        dec     edi
        loop    IFile1

        mov     esi,offset ssf
        mov     edi,edx
        or      ecx,sizeof SavedSettingsFile/4
        repz    cmpsd
        jz      IFile2

        pop     eax
        mov     edi,edx
        push    eax
        INVOKE  OpnFile,eax,FILECREATE
        inc     eax
        jz      IFile2

        dec     eax
        push    eax                                  ;CloseHandle:hObject
        push    eax
        mov     edx,esp
        INVOKE  WriteFile,eax,edi,sizeof SavedSettingsFile,edx,NULL
        pop     ecx
        CALL    CloseHandle

IFile2: CALL    HFree
        ret

dWinExit ENDP

;*************************************************************************************************************

_main   PROC

;----------------------

;initialization

        call    dWinInit

;EBX = hMenu
;EBP = main window initial show state (SW_SHOWNORMAL / SW_SHOWMAXIMIZED)
;ESI = offset WndClass
;EDI = 0

;## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##

;test code

;fill the text buffer - static

        cmp     edi,static_ctrl
        jz      run_thrd

        call    TestTxt ;test code
        call    TextCalc

run_thrd:


;## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##

;create and update the main window

        INVOKE  CreateWindowEx,edi,esi,ams.AppNamePtr,
                WS_OVERLAPPEDWINDOW or WS_VISIBLE or WS_CLIPCHILDREN,
                CW_USEDEFAULT,ebp,vs.WndWidth,vs.WndHeight,edi,ebx,hInstance,edi
        push    eax                                ;UpdateWindow:hWnd
        CALL    UpdateWindow

;## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##

;test code

        call    ThrdTxt

;## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##

;----------------------

;message loop

;MSG STRUCT
; hwnd             dd ?
; message          dd ?
; wParam           dd ?
; lParam           dd ?
; time             dd ?
; pt               POINT <>
;   x                dw ?
;   y                dw ?

        pushad                                     ;create stack space for MSG structure
        cmp     edi,ams.hRcvr
        mov byte ptr sUpdateEnable,-1
        mov byte ptr dUpdateMode,DMODE_FULL_AUTO
        mov     ebp,esp
        jnz     mLoop0

        INVOKE  CreateThread,edi,edi,UsrThrd,edi,edi,edi
        jmp short mLoop2

mLoop0: INVOKE  SndAck,edi

call TextReady

        jmp short mLoop2

mLoop1: INVOKE  TranslateMessage,ebp
        INVOKE  DispatchMessage,ebp

mLoop2: INVOKE  GetMessage,ebp,edi,edi,edi
        inc     eax                                ;exit only
        shr     eax,1                              ;if 0 or -1
        jnz     mLoop1

;----------------------

;exit _main

        INVOKE  HFree,hBlock
        pop     eax                                ;EAX = MSG.hWnd, [ESP] = MSG.message
        JMP     ExitProcess                        ;[ESP+4] = MSG.wParam

_main   ENDP

;*************************************************************************************************************

wmCreate PROC

;EDX = hWnd

;create text and control windows

        push    6
        mov     ebx,edx                                                     ;EBX = hWnd
        xor     edi,edi                                                     ;EDI = 0
        mov     eax,CID_STATUSBAR                                           ;EAX = control ID
        and     MaxFlag,ebx
        pop     ecx                                                         ;ECX = loop count
        mov     esi,offset WinCreateTable                                   ;ESI = table pointer
        mov     hWin,ebx
        mov     edx,offset ControlHandles                                   ;EDX = handle pointer

CrWin0: push    eax
        push    ecx
        push    edx
        push    edi                                                         ;CreateWindowEx:lpParam
        push    hInstance                                                   ;CreateWindowEx:hInstance
        push    eax                                                         ;CreateWindowEx:hMenu (control ID)
        push    ebx                                                         ;CreateWindowEx:hWndParent
        push    edi                                                         ;CreateWindowEx:nHeight
        lodsd
        push    edi                                                         ;CreateWindowEx:nWidth
        push    edi                                                         ;CreateWindowEx:y
        push    edi                                                         ;CreateWindowEx:x
        push    eax                                                         ;CreateWindowEx:dwStyle
        lodsd
        push    edi                                                         ;CreateWindowEx:lpWindowName
        push    eax                                                         ;CreateWindowEx:lpClassName
        push    edi                                                         ;CreateWindowEx:dwExStyle
        CALL    CreateWindowEx
        pop     edx
        pop     ecx
        mov     [edx],eax                                                   ;store the handle
        pop     eax
        add     edx,4                                                       ;point to next handle
        shl     al,1                                                        ;next control ID
        loop    CrWin0

;----------------------

;initialize status bar size and position values

        call    StMet
        push    edx
        push    pr.right
        INVOKE  ScreenToClient,ebx,esp
        pop     StbWidth
        pop     StbPosY
        ret

wmCreate ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

DeRef   PROC    lpStart:DWORD,lpStop:DWORD,lpExclusions:DWORD

;Dereference IAT Branches
;DednDave - 7, 2011
;
;  Dereferences all branches into the IAT, starting at lpStart, and ending at lpStop.
;If lpStop is NULL, the beginning of the IAT is used as the stop address.
;An exclusion list may be used to exclude specific addresses from conversion.
;Addresses in the list represent the address of the first instruction byte.
;If present, the list must be terminated with a NULL dword.
;No exclusion list is used if the lpExclusions parameter is NULL.
;
;  This version allows for the conversion of JMP's, CALL's and conditional branches.
;It will convert declspec JMP's and CALL's, including those into the MSVCRT, etc.
;
;  The converted instructions always result in a relative branch directly to the imported code.
;This will prevent hooking into the IAT, which may be overridden by hooking prior to DeRef
;execution or by use of the exclusion list.
;
;----------------------------------------------------
;
;[EBP+28] = lpExclusions
;[EBP+24] = lpStop
;[EBP+20] = lpStart
;[EBP-4]  = address of IAT start
;[EBP-8]  = address of IAT end
;[EBP-12] = adjusted lpStop (lpStop-4)
;[EBP-16] = original access protection value
;[EBP-20] = dereference count
;
;----------------------------------------------------

        push    ebx
        push    esi
        push    edi
        push    ebp
        push    6
        xor     edx,edx
        pop     ebx
        mov     esi,VirtualProtect
        mov     ebp,esp
        mov     eax,25FFh
        push    esi
        jmp short DeRef1

DeRef0: mov     edx,esi
        sub     esi,ebx

DeRef1: cmp     ax,[esi]
        jz      DeRef0

        pop     esi
        or      edx,edx
        push    edx                        ;[EBP-4] = address of IAT start
        jz      DeRefL

DeRef2: mov     ecx,esi
        add     esi,ebx
        cmp     ax,[esi]
        jz      DeRef2

        mov     edi,[ebp+24]               ;lpStop
        add     ecx,2
        or      edi,edi
        push    ecx                        ;[EBP-8] = address of IAT end
        jnz     DeRef3

        mov     edi,edx

DeRef3: mov     edx,edi
        mov     esi,[ebp+20]               ;lpStart
        sub     edx,4
        sub     edi,esi
        push    edx                        ;[EBP-12] = adjusted lpStop (lpStop-4)
        mov     [ebp+24],edi               ;[EBP+24] is now code stream length
        push    eax                        ;[EBP-16] = previous access protection value
        INVOKE  VirtualProtect,esi,edi,PAGE_EXECUTE_READWRITE,esp
        or      eax,eax
        push    0                          ;[EBP-20] = dereference count
        jnz     DeRefH

        jmp     DeRefL

DeRef4: xor     ecx,ecx
        cmp     al,0E8h                    ;CALL relative (to JMP indirect)
        mov     edx,ecx
        jz      DeRef5

        cmp     al,0E9h                    ;JMP relative (to JMP indirect)
        jz      DeRef6

        inc     ecx
        cmp     ax,15FFh                   ;CALL indirect (declspec)
        mov     edx,ecx
        jz      DeRef6

        cmp     ax,25FFh                   ;JMP indirect (declspec)
        jz      DeRef6

        dec     edx
        cmp     al,0Fh                     ;relative conditional branch candidate
        jnz     DeRefI

        cmp     ah,80h                     ;relative conditional branch candidate
        jb      DeRefI

        cmp     ah,8Fh                     ;relative conditional branch (to JMP indirect)
        jbe     DeRef6

        jmp     DeRefI

DeRef5: cmp     esi,offset DeRefL-4
        jz      DeRefI

DeRef6: mov     edi,esi
        add     edi,ecx
        cmp     edi,[ebp-12]               ;adjusted lpStop (lpStop-4)
        ja      DeRefK

        or      edx,edx
        mov     ebx,[edi]
        jz      DeRef9

        push    esi
        mov     esi,[ebp-4]                ;address of IAT start
        add     esi,2

DeRef7: cmp     ebx,[esi]
        jnz     DeRef8

        pop     esi
        jmp short DeRefA

DeRef8: add     esi,6
        cmp     esi,[ebp-8]                ;address of IAT end
        jbe     DeRef7

        pop     esi
        jmp     DeRefI

DeRef9: add     ebx,edi
        add     ebx,4
        cmp     ebx,[ebp-4]                ;address of IAT start
        jb      DeRefI

        cmp     ebx,[ebp-8]                ;address of IAT end
        ja      DeRefI

        push    ebx
        push    eax
        push    edx
        sub     ebx,[ebp-4]                ;address of IAT start
        mov     eax,0AAAAAAABh
        push    ebx
        mul     ebx
        shr     edx,2
        mov     eax,6
        mul     edx
        pop     ebx
        cmp     eax,ebx
        pop     edx
        pop     eax
        pop     ebx
        jnz     DeRefI

DeRefA: mov     ecx,[ebp+28]               ;lpExclusions
        or      ecx,ecx
        jz      DeRefD

        push    eax
        dec     esi
        jmp short DeRefC

DeRefB: add     ecx,4
        cmp     eax,esi
        jnz     DeRefC

        inc     esi
        pop     eax
        jmp short DeRefI

DeRefC: mov     eax,[ecx]
        or      eax,eax
        jnz     DeRefB

        inc     esi
        pop     eax

DeRefD: or      edx,edx
        jz      DeRefF

        cmp     ah,15h
        mov     ebx,[ebx]
        mov     ax,0E890h
        jz      DeRefE

        inc     ah

DeRefE: mov     [esi-1],ax
        jmp short DeRefG

DeRefF: mov     ecx,[ebx+2]
        mov     ebx,[ecx]

DeRefG: sub     ebx,edi
        sub     ebx,4
        mov     [edi],ebx
        inc dword ptr [ebp-20]             ;dereference count
        add     edi,4
        mov     esi,edi

DeRefH: mov     ax,[esi]
        inc     esi
        jmp short DeRefJ

DeRefI: inc     esi
        mov     al,ah
        mov     ah,[esi]

DeRefJ: cmp     esi,[ebp-12]               ;adjusted lpStop (lpStop-4)
        jbe     DeRef4

DeRefK: lea     edx,[ebp-12]
        INVOKE  VirtualProtect,[ebp+20],[ebp+24],[ebp-16],edx

DeRefL: pop     eax                        ;return dereference count
        leave
        pop     edi
        pop     esi
        pop     ebx
        ret     12

DeRef   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

EnumFntCB PROC  lpLogFont:DWORD,lpMetric:DWORD,fType:DWORD,lParam:DWORD

;font enumeration callback routine

        mov     edx,FeCount                     ;FeCount is a pointer for now
        cmp     edx,offset FeList+2*FELISTLENGTH
        jae     EnFCB3                          ;skip if buffer is full

        mov     ecx,[esp+4]                     ;ECX = LOGFONT structure ptr
        mov     eax,[ecx]                       ;AL = cell height
        cmp     eax,35
        ja      EnFCB3                          ;skip if height is greater than 35 pixels

        cmp dword ptr [ecx+4],35
        ja      EnFCB3                          ;skip if width is greater than 35 pixels

        mov     ah,[ecx+4]                      ;AH = cell width
        cmp     al,ah
        jb      EnFCB3                          ;skip if height is less than width

        cmp     ah,4
        jb      EnFCB3                          ;skip if width is less than 4 pixels

;skip if already in the list

        push    edx

EnFCB0: dec     edx
        dec     edx
        cmp     edx,offset FeList
        jb      EnFCB2

EnFCB1: cmp     ax,[edx]
        jnz     EnFCB0

EnFCB2: pop     edx
        jz      EnFCB3

        mov     [edx],ax
        inc     edx
        inc     edx
        mov     FeCount,edx

EnFCB3: ret     16

EnumFntCB ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

dWinInit PROC

;initialization code

;  Returns: EBX = hMenu
;           EBP = main window initial show state (SW_SHOWNORMAL / SW_SHOWMAXIMIZED)
;           ESI = offset WndClass
;           EDI = 0

;*********************************************************
;dereference IAT branches
;*********************************************************

        xor     edi,edi
;        INVOKE  DeRef,WndProc,UsrCode,edi

;*********************************************************
;ICC, hInstance, hIcon, hCursor, command line
;*********************************************************

        push    ICC_WIN95_CLASSES
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp
        pop     ecx
        or      eax,eax
        pop     edx
        jnz     Start1

        mov     esi,offset IccErrText

Start0: INVOKE  MessageBox,edi,esi,ams.AppNamePtr,MB_ICONERROR
        INVOKE  ExitProcess,esi

Start1: INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        INVOKE  LoadIcon,eax,IDI_ICON
        mov     hIcon,eax
        INVOKE  LoadCursor,edi,IDC_ARROW
        mov     hCursor,eax
        INVOKE  GetCommandLine
        mov     ecx,edi
        mov     dx,2220h                       ;double quote and space
        mov     lpCmndLineFull,eax

Start2: cmp     cl,dh                          ;double quote
        jnz     Start4

Start3: mov     cl,[eax]
        jecxz   Start6

        inc     eax
        cmp     cl,dh                          ;double quote
        jnz     Start3

Start4: mov     cl,[eax]
        jecxz   Start6

        inc     eax
        cmp     cl,dl                          ;space
        jnz     Start2

Start5: mov     cl,[eax]
        inc     eax
        cmp     cl,dl                          ;space
        jz      Start5

        dec     eax

Start6: mov     lpCmndLine,eax

;parse the command line for a valid ASCII hexadecimal handle

        push    8
        mov     ebx,edi
        pop     ecx

Start7: movzx   edx,byte ptr [eax]
        sub     dl,30h
        cmp     dl,9
        jbe     Start8

        and     dl,0DFh
        sub     dl,7
        cmp     dl,0Fh
        ja      Valid0

Start8: shl     ebx,4
        or      ebx,edx
        inc     eax
        loop    Start7

        or      ebx,ebx
        jz      Valid0

        mov     edi,offset ams
        xchg    eax,ebx
        lea     esi,[edi].AppModeStruct.nPmaBaseCmd
        stosd
        movsd
        movsd
        movsd
        movsd
        mov     edi,ecx

;*********************************************************
;validate text buffer dimensions and set constants
;*********************************************************

Valid0: mov     eax,BufferColumns
        mov     edx,256                        ;max columns
        or      eax,eax
        jnz     Valid1

        mov     eax,BUFFER_COLUMNS

Valid1: cmp     eax,edx
        ja      Valid2

        xchg    eax,edx

Valid2: mov     BufferColumns,edx
        mov     eax,edx
        add     edx,5
        shl     eax,3
        and     edx,-4
        add     eax,WINDOW_WIDTH_ADD
        mov     RowLength,edx                  ;(BufferColumns+5) AND 0FFFFFFFCh
        mov     vs.WndWidth,eax
        mov     ecx,edx
        mov     eax,BufferRows
        shr     ecx,2
        or      eax,eax
        mov     BufCalc1,ecx                   ;RowLength/4
        jnz     Valid3

        mov     eax,BUFFER_ROWS

Valid3: cmp     eax,1024                       ;max rows
        jbe     Valid4

        mov     eax,1024

Valid4: mov     BufferRows,eax
        dec     eax
        mov     BufCalc2,eax                   ;BufferRows-1
        mov     LastRow,eax
        imul    eax,ecx
        add     ecx,eax
        mov     BufCalc3,eax                   ;RowLength*(BufferRows-1)/4
        mov     BufCalc4,ecx                   ;RowLength*BufferRows/4
        inc     ecx
        shl     eax,2
        push    edx
        shl     ecx,2
        push    eax
        push    ecx

;*********************************************************
;allocate display text buffer memory
;*********************************************************

        INVOKE  GetProcessHeap
        pop     edx
        mov     hHeap,eax
        INVOKE  HeapAlloc,eax,HEAP_ZERO_MEMORY,edx
        or      eax,eax
        jnz     aHeap0

        mov     esi,offset AllocErrText
        jmp     Start0

aHeap0: mov     hBlock,eax
        pop     edx
        add     eax,3
        and     eax,-4
        pop     ecx
        add     edx,eax
        add     ecx,eax
        mov     LastRowAddr,edx
        mov     SecondRowAddr,ecx
        mov     BlockUsed,eax

;*********************************************************
;read saved view settings
;*********************************************************

        mov     ebp,edi
        call    MakeIFn
        push    eax                    ;HFree:hBlck
        mov     edi,ecx
        mov     ebx,ebp
        INVOKE  OpnFile,eax,FILEREAD
        inc     eax
        mov     esi,offset ssf         ;SavedSettingsFile structure
        jz      RFile0

        dec     eax
        push    edx
        xchg    eax,ebx
        push    ecx
        INVOKE  GetFileSizeEx,ebx,esp
        pop     eax
        pop     edx
        cmp     eax,sizeof SavedSettingsFile
        jnz     RFile0

        or      edx,edx
        jnz     RFile0

        push    eax
        push    eax
        mov     ecx,esp
        INVOKE  ReadFile,ebx,esi,eax,ecx,edx
        pop     ecx
        or      eax,eax
        pop     edx
        jz      RFile0

        cmp     ecx,edx
        jnz     RFile0

        push    10
        pop     ecx
        push    esi
        repz    cmpsb
        movzx   eax,word ptr [esi]
        pop     esi
        jnz     RFile0

        cmp     eax,edx
        jz      RFile1

RFile0: mov     [esi],ebp
        mov     edi,offset CustomBack
        call    CcRst
        call    CcRst
        jmp     RFile3

RFile1: add     esi,12
        mov     edi,offset vs            ;ViewSettings structure
        lodsw                            ;ssf.wWindowWidth
        push    MF_CHECKED
        stosd                            ;vs.WndWidth
        lodsw                            ;ssf.wWindowHeight
        pop     ecx
        stosd                            ;vs.WndHeight
        lodsw                            ;ssf.wFlagsTextSize
        mov     ebp,eax
        shr     ebp,4
        and     ebp,2                    ;EBP = show state
        mov     edx,eax
        shr     edx,3
        and     edx,ecx
        mov     StbState,edx
        mov     edx,eax
        shr     edx,4
        and     edx,ecx
        mov     ShftVrtState,edx
        mov     edx,eax
        shr     edx,10
        and     edx,ecx
        mov     CtrlVrtState,edx
        mov     edx,eax
        shr     edx,11
        and     edx,ecx
        mov     HrzState,edx
        mov     edx,eax
        shr     edx,12
        and     edx,ecx
        mov     ShftHrzState,edx
        and     eax,1F1Fh
        add     eax,404h
        mov     edx,0FFFFFFh
        stosd                            ;vs.DefaultTextSize
        lodsd                            ;ssf.rgbBackColor
        dec     esi
        and     eax,edx
        stosd                            ;vs.BackColor
        lodsd                            ;ssf.rgbForeColor
        dec     esi
        and     eax,edx
        stosd                            ;vs.ForeColor
        push    32
        mov     edi,offset CustomBack
        pop     ecx

RFile2: lodsd
        dec     esi
        and     eax,edx
        stosd
        loop    RFile2

RFile3: or      ebx,ebx
        jz      RFile4

        INVOKE  CloseHandle,ebx

RFile4: inc     ebp                      ;SW_SHOWNORMAL EQU 1, SW_SHOWMAXIMIZED EQU 3
        CALL    HFree
        push    ebp                      ;main window show state on stack

;*********************************************************
;get system metrics and justify main window size
;*********************************************************

        call    ScMet                               ;scrollbar metrics
        call    WkMet                               ;working screen size metrics
        mov     ecx,offset vs
        xor     edi,edi
        cmp     edx,[ecx].ViewSettings.WndWidth
        jae     IMetr0

        mov     [ecx].ViewSettings.WndWidth,edx

IMetr0: cmp     eax,[ecx].ViewSettings.WndHeight
        jae     FEnum0

        mov     [ecx].ViewSettings.WndHeight,eax

;*********************************************************
;enumerate "Terminal" font sizes
;*********************************************************

FEnum0: INVOKE  GetDC,edi
        mov     edx,offset lf
        push    eax                                          ;ReleaseDC:hDC
        mov dword ptr [edx].LOGFONT.lfFaceName,6D726554h     ;'Term'
        mov dword ptr [edx].LOGFONT.lfFaceName+4,6C616E69h   ;'inal'
        mov byte ptr [edx].LOGFONT.lfFaceName+8,0            ;string terminator
        mov byte ptr [edx].LOGFONT.lfCharSet,OEM_CHARSET     ;EQU 255
        mov byte ptr [edx].LOGFONT.lfPitchAndFamily,0
        INVOKE  EnumFontFamiliesEx,eax,edx,EnumFntCB,edi,edi
        push    edi                                          ;ReleaseDC:hWnd
        CALL    ReleaseDC

;*********************************************************
;create main menu
;*********************************************************

        INVOKE  CreateMenu
        mov     hMenu,eax
        mov     esi,offset MenuTable
        or      edi,MAIN_MENU_ITEMS                       ;4
        xchg    eax,ebx                                   ;EBX = hMenu

MMenu0: INVOKE  CreatePopupMenu
        push    eax
        lodsd
        xchg    eax,ebp

MMenu1: pop     edx
        lodsd
        push    edx
        push    eax
        lodsd
        push    eax
        lodsd
        push    eax
        push    edx
        CALL    AppendMenu
        dec     ebp
        jnz     MMenu1

        pop     edx
        lodsd
        push    edx
        INVOKE  AppendMenu,ebx,MF_POPUP,edx,eax
        dec     edi
        jnz     MMenu0

        pop     ecx          ;discard Help menu handle
        pop     ebp          ;EBP = View menu handle
        pop     hEditMenu    ;store Edit menu handle
        pop     edx          ;discard File menu handle
        or      edi,2

MMenu2: INVOKE  CreatePopupMenu
        xchg    eax,edx
        lodsd
        xchg    eax,ecx

MMenu3: push    edx
        lodsd
        push    ecx
        push    eax
        lodsd
        push    eax
        lodsd
        push    eax
        push    edx
        CALL    AppendMenu
        pop     ecx
        pop     edx
        loop    MMenu3

        or      ecx,3
        sub     ecx,edi
        lodsd
        shl     ecx,1
        INVOKE  InsertMenu,ebp,ecx,MF_BYPOSITION or MF_POPUP,edx,eax
        dec     edi
        jnz     MMenu2

;----------------------

;calculate the text size list length
;the length must be greater than 1 to make a text size menu ;)

        mov     ecx,FeCount
        mov     edx,offset FeList
        sub     ecx,edx
        shr     ecx,1
        mov     FeCount,ecx
        jz      MMenuF        ;use default if 0

        dec     ecx
        jnz     MMenu4

        mov     edx,IDM_TEXT_SIZE
        call    FontSize
        jmp     MMenuF

;----------------------

;sort the text size list

;EBX = hMenu
;ECX = text size list length
;EDX = offset FeList
;EBP = View menu handle
;EDI = 0

MMenu4: push    ebx
        push    ebp

MMenu5: push    edx
        movzx   eax,word ptr [edx]
        push    ecx

MMenu6: push    ecx
        movzx   ecx,word ptr [edx+2]
        cmp     eax,ecx
        ja      MMenu7

        xchg    eax,ecx
        jmp short MMenu8

MMenu7: mov     [edx],cx
        mov     [edx+2],ax

MMenu8: pop     ecx
        inc     edx
        inc     edx
        loop    MMenu6

        pop     ecx
        pop     edx
        loop    MMenu5

;----------------------

;create text size popup menu

;EDX = offset FeList

        push    edx
        INVOKE  CreatePopupMenu
        pop     edx
        mov     bx,3030h
        mov     esi,IDM_TEXT_SIZE
        xchg    eax,ebp
        push    edx
        push    ecx
        push    eax
        mov     ecx,FeCount
        mov     edi,esp

MMenu9: movzx   eax,word ptr [edx]
        push    edi
        push    eax
        mov     al,ah
        aam
        or      eax,ebx
        cmp     ah,bl
        jz      MMenuA

        mov     [edi],ah
        inc     edi

MMenuA: mov     ah,'x'
        stosw
        pop     eax
        aam
        or      eax,ebx
        cmp     ah,bl
        jz      MMenuB

        mov     [edi],ah
        inc     edi

MMenuB: mov     ah,0
        inc     edx
        stosw
        inc     edx
        pop     edi
        push    edx
        push    ecx
        INVOKE  AppendMenu,ebp,MF_STRING,esi,edi
        pop     ecx
        inc     esi
        pop     edx
        inc     esi
        loop    MMenu9

        pop     ebx
        pop     eax
        pop     ebx
        pop     eax
        INVOKE  InsertMenu,eax,ecx,MF_BYPOSITION or MF_POPUP,ebp,offset szTextSize

;----------------------

;select the default text size

;EBX = offset FeList

        mov     eax,FeCount
        or      esi,-1
        mov     edi,eax
        shl     eax,1
        add     eax,IDM_TEXT_SIZE
        mov     ecx,vs.DefaultTextSize
        mov     FeCount,eax

MMenuC: movzx   eax,word ptr [ebx]
        sub     eax,ecx
        jnc     MMenuD

        neg     eax

MMenuD: cmp     eax,esi
        ja      MMenuE

        mov     edx,ebx
        xchg    eax,esi

MMenuE: inc     ebx
        inc     ebx
        dec     edi
        jnz     MMenuC

;----------------------

;implement the selected text size

        sub     edx,offset FeList-IDM_TEXT_SIZE
        call    SelectSize
        pop     ebx

;----------------------

;create a handle for the selected text size

MMenuF: call    MakeFont

;*********************************************************
;register window classes
;*********************************************************

;WNDCLASSEX STRUCT
; cbSize           dd ?
; style            dd ?
; lpfnWndProc      dd ?
; cbClsExtra       dd ?
; cbWndExtra       dd ?
; hInstance        dd ?
; hIcon            dd ?
; hCursor          dd ?
; hbrBackground    dd ?
; lpszMenuName     dd ?
; lpszClassName    dd ?
; hIconSm          dd ?

;EDI = 0

RegTwo: INVOKE  CreateSolidBrush,vs.BackColor
        mov     edx,hIcon
        mov     ecx,TxtProc
        push    edx
        mov     esi,offset TxtClass
        call    RegOne
        mov     eax,COLOR_SCROLLBAR+1
        pop     edx
        mov     esi,offset WndClass
        pop     ebp                                     ;EBP = main window show state
        mov     ecx,WndProc

RegOne: push    edx                                     ;hIconSm
        push    esi                                     ;lpszClassName
        push    edi                                     ;lpszMenuName
        push    eax                                     ;hbrBackground
        push    hCursor                                 ;hCursor
        push    edx                                     ;hIcon
        push    hInstance                               ;hInstance
        push    edi                                     ;cbWndExtra
        push    edi                                     ;cbClsExtra
        push    ecx                                     ;lpfnWndProc
        push    edi                                     ;style
        push    sizeof WNDCLASSEX                       ;cbSize
        INVOKE  RegisterClassEx,esp
        add     esp,sizeof WNDCLASSEX
        ret

dWinInit ENDP

;*************************************************************************************************************

OpnPres PROC

;execute the presentation manager app

        push    edi
        push    ebx
        xor     edi,edi
        push    esi
        cmp     edi,ams.hRcvr
        mov     ebx,250                             ;time interval size = 250 mS
        jnz     OPres1

        INVOKE  Sleep,ebx
        push    (sizeof STARTUPINFO-4)/4
        INVOKE  B2Hex,hWin,offset PmCmdLine         ;pass hWin to the PM on the command line as ASCII hex
        pop     ecx
        xor     eax,eax
        sub     esp,sizeof STARTUPINFO+sizeof PROCESS_INFORMATION-4
        mov     edi,esp
        rep     stosd
        push    sizeof STARTUPINFO
        xchg    eax,edi
        mov     edx,esp
        push    40                                  ;timeout interval count = 40 (x 250 mS = 10 seconds)
        INVOKE  CreateProcess,edi,offset PmAppName,edi,edi,edi,
                CREATE_NEW_PROCESS_GROUP or NORMAL_PRIORITY_CLASS,
                edi,edi,edx,eax
        or      eax,eax
        pop     esi
        jz      OPres2

OPres0: INVOKE  Sleep,ebx
        dec     esi
        jz      OPres2

        cmp     edi,ams.hRcvr
        jz      OPres0

        add     esp,sizeof STARTUPINFO+sizeof PROCESS_INFORMATION

OPres1: pop     esi
        pop     ebx
        pop     edi
        ret

OPres2: INVOKE  MessageBox,hWin,offset PmaErrText,ams.AppNamePtr,MB_ICONERROR
        INVOKE  DeleteObject,hFont
        INVOKE  HFree,hBlock
        INVOKE  ExitProcess,edi

OpnPres ENDP

;*************************************************************************************************************

UsrThrd PROC

;only started if ams.hRcvr = 0

        call    UsrCode
        INVOKE  ExitThread,0

UsrThrd ENDP

;*************************************************************************************************************

        INCLUDE UserCode.inc

        IFNDEF UsrCode

UsrCode PROC

        ret

UsrCode ENDP

        ENDIF

;#############################################################################################################

;test code section

;#############################################################################################################

TestTxt PROC

;test code - fill the buffer with text

        push    BufferColumns
        mov     edx,BlockUsed
        mov     ecx,BufferRows
        pop     cg.h.CellsUsed
        push    edx
        mov     cg.v.CellsUsed,ecx
        mov     al,'0'
        push    ecx

tFill0: push    ecx
        push    edx
        push    eax
        mov     ecx,BufferColumns
        mov     [edx],cx
        inc     edx
        inc     edx

tFill1: mov     [edx],al
        inc     eax
        cmp     al,'z'
        jbe     tFill2

        mov     al,'0'

tFill2: inc     edx
        loop    tFill1

        pop     eax
        pop     edx
        pop     ecx
        inc     eax
        cmp     al,'z'
        jbe     tFill3

        mov     al,'0'

tFill3: add     edx,RowLength
        loop    tFill0

;----------------------

;test code - last char = 219

        pop     eax                      ;EAX = cg.v.CellsUsed
        mov     ecx,RowLength
        add     edx,cg.h.CellsUsed
        inc     edx
        sub     edx,ecx
        mov byte ptr [edx],219

;----------------------

;test code - one line with spaces on the right

        shr     eax,1
        mul     ecx
        pop     edx                      ;EDX = BlockUsed
        push    ecx
        add     edx,eax
        movzx   ecx,word ptr [edx]
        mov     eax,ecx
        shr     eax,1
        mov     [edx],ax
        inc     edx
        inc     edx
        push    edx
        push    eax
        sub     ecx,eax
        add     edx,eax
        mov     al,20h

tFill4: mov     [edx],al
        inc     edx
        loop    tFill4

;----------------------

;test code - one line with spaces on the left

        pop     ecx
        pop     edx
        pop     eax
        add     edx,eax
        mov     al,20h

tFill5: mov     [edx],al
        inc     edx
        loop    tFill5

        ret

TestTxt ENDP

;*************************************************************************************************************

ThrdTxt PROC

        mov     ecx,thrd_ctrl
        jecxz   tText3

        push    edi
        mov     edi,offset TxtBuf
        mov     ecx,BUFFER_COLUMNS+1
        jmp short tText1

tText0: stosb
        inc     eax
        cmp     al,'z'
        jbe     tText2

tText1: mov     al,'0'

tText2: loop    tText0

        INVOKE  CreateThread,ecx,ecx,TxtThrd,ecx,ecx,ecx
        pop     edi

tText3: ret

ThrdTxt ENDP

;*************************************************************************************************************

TxtThrd PROC

        mov     eax,thrd_mode
        call    ChangeMode
        INVOKE  Sleep,1000

;invoke SetWindowText,hWin,offset szWheel  ;test code

tThrd0: INVOKE  dTxtOut,offset teststr ;offset TxtBuf
        dec dword ptr testcnt
        jnz test00

        mov dword ptr testcnt,8
        call    dNewLine

test00:
        INVOKE  Sleep,thrd_time1
;        INVOKE  dClrLine,5,0
;        INVOKE  Sleep,thrd_time2
        mov     edi,offset TxtBuf
        lea     esi,[edi+1]
        mov     ecx,BUFFER_COLUMNS-1
        rep     movsb
        mov     al,[edi-1]
        inc     eax
        cmp     al,'z'
        jbe     tThrd1

        mov     al,'0'

tThrd1: stosb
        xor     eax,eax
        cmp     al,thrdend
        jnz     tThrd0

        xchg    al,thrdended
        INVOKE  ExitThread,eax

TxtThrd ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

HexOut  PROC    xval:DWORD,xline:DWORD

        mov     eax,RowLength
        mul dword ptr [esp+8]
        mov     edx,BlockUsed
        push    8
        add     edx,eax
        pop     ecx
        inc     edx
        mov     eax,[esp+4]
        mov byte ptr [edx+ecx+1],20h

HLoop0: push    eax
        and     al,0Fh
        cmp     al,0Ah
        sbb     al,69h
        das                              ;0-9 > '0'-'9', 10-15 > 'A'-'F'
        mov     [edx+ecx],al
        pop     eax
        shr     eax,4
        loop    HLoop0

        ret     8

HexOut  ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;#############################################################################################################

        END     _main

